/**
 * @file
 * @brief  The generated interface for the register allocator.
 *          Contains register classes and types and register constraints
 *          for all nodes where constraints were given in spec.
 * @note    DO NOT EDIT THIS FILE, your changes will be lost.
 *          Edit libfirm/ir/be/TEMPLATE/TEMPLATE_spec.pl instead.
 *          created by: libfirm/ir/be/scripts/generate_regalloc_if.pl libfirm/ir/be/TEMPLATE/TEMPLATE_spec.pl libfirm/ir/be/TEMPLATE
 * $date    Thu Nov 13 15:07:51 2008
 */
#include "config.h"

#include "gen_TEMPLATE_regalloc_if.h"
#include "gen_TEMPLATE_machine.h"
#include "bearch_TEMPLATE_t.h"
#include "TEMPLATE_map_regs.h"
#include "irmode.h"

arch_register_class_t TEMPLATE_reg_classes[] = {
	{ 0, "TEMPLATE_general_purpose", N_TEMPLATE_general_purpose_REGS, NULL, TEMPLATE_general_purpose_regs, 0 },
	{ 1, "TEMPLATE_floating_point", N_TEMPLATE_floating_point_REGS, NULL, TEMPLATE_floating_point_regs, 0 }
};

const arch_register_t TEMPLATE_general_purpose_regs[N_TEMPLATE_general_purpose_REGS] = {
	{
		"r0",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_R0,
		arch_register_type_caller_save
	},
	{
		"r1",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_R1,
		arch_register_type_caller_save
	},
	{
		"r2",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_R2,
		arch_register_type_caller_save
	},
	{
		"r3",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_R3,
		arch_register_type_caller_save
	},
	{
		"r4",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_R4,
		arch_register_type_caller_save
	},
	{
		"r5",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_R5,
		arch_register_type_caller_save
	},
	{
		"r6",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_R6,
		arch_register_type_caller_save
	},
	{
		"r7",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_R7,
		arch_register_type_callee_save
	},
	{
		"r8",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_R8,
		arch_register_type_callee_save
	},
	{
		"r9",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_R9,
		arch_register_type_callee_save
	},
	{
		"r10",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_R10,
		arch_register_type_callee_save
	},
	{
		"r11",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_R11,
		arch_register_type_callee_save
	},
	{
		"r12",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_R12,
		arch_register_type_callee_save
	},
	{
		"r13",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_R13,
		arch_register_type_callee_save
	},
	{
		"r14",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_SP,
		arch_register_type_ignore
	},
	{
		"r15",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose],
		REG_BP,
		arch_register_type_ignore
	},
};
const arch_register_t TEMPLATE_floating_point_regs[N_TEMPLATE_floating_point_REGS] = {
	{
		"f0",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F0,
		arch_register_type_caller_save
	},
	{
		"f1",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F1,
		arch_register_type_caller_save
	},
	{
		"f2",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F2,
		arch_register_type_caller_save
	},
	{
		"f3",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F3,
		arch_register_type_caller_save
	},
	{
		"f4",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F4,
		arch_register_type_caller_save
	},
	{
		"f5",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F5,
		arch_register_type_caller_save
	},
	{
		"f6",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F6,
		arch_register_type_caller_save
	},
	{
		"f7",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F7,
		arch_register_type_caller_save
	},
	{
		"f8",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F8,
		arch_register_type_caller_save
	},
	{
		"f9",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F9,
		arch_register_type_caller_save
	},
	{
		"f10",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F10,
		arch_register_type_caller_save
	},
	{
		"f11",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F11,
		arch_register_type_caller_save
	},
	{
		"f12",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F12,
		arch_register_type_caller_save
	},
	{
		"f13",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F13,
		arch_register_type_caller_save
	},
	{
		"f14",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F14,
		arch_register_type_caller_save
	},
	{
		"f15",
		&TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point],
		REG_F15,
		arch_register_type_caller_save
	},
};

void TEMPLATE_register_init(void) {
	/* set largest possible mode for 'TEMPLATE_general_purpose' */
	TEMPLATE_reg_classes[CLASS_TEMPLATE_general_purpose].mode = mode_Iu;

	/* set largest possible mode for 'TEMPLATE_floating_point' */
	TEMPLATE_reg_classes[CLASS_TEMPLATE_floating_point].mode = mode_D;

}

