/**
 * @file
 * @brief Function prototypes for the new opcode functions.
 * @note  DO NOT EDIT THIS FILE, your changes will be lost.
 *        Edit libfirm/ir/be/ia32/ia32_spec.pl instead.
 *        created by: libfirm/ir/be/scripts/generate_new_opcodes.pl libfirm/ir/be/ia32/ia32_spec.pl libfirm/ir/be/ia32
 * @date  Sat Nov 22 08:31:00 2008
 */
#ifndef FIRM_BE_IA32_GEN_IA32_NEW_NODES_H
#define FIRM_BE_IA32_GEN_IA32_NEW_NODES_H

typedef enum _ia32_opcodes {
	iro_ia32_xZero,
	iro_ia32_FldCW,
	iro_ia32_fadd,
	iro_ia32_ShrMem,
	iro_ia32_Immediate,
	iro_ia32_CvtSI2SS,
	iro_ia32_LdTls,
	iro_ia32_ShlD,
	iro_ia32_PopEbp,
	iro_ia32_Inc,
	iro_ia32_xStore,
	iro_ia32_l_ShlD,
	iro_ia32_xxLoad,
	iro_ia32_xAnd,
	iro_ia32_GetEIP,
	iro_ia32_xAdd,
	iro_ia32_xPsllq,
	iro_ia32_xxStore,
	iro_ia32_Call,
	iro_ia32_FnstCWNOP,
	iro_ia32_vFtstFnstsw,
	iro_ia32_XorMem8Bit,
	iro_ia32_fldl2t,
	iro_ia32_fisttp,
	iro_ia32_DecMem,
	iro_ia32_emms,
	iro_ia32_fdivr,
	iro_ia32_Unknown_VFP,
	iro_ia32_vfprem,
	iro_ia32_xLoad,
	iro_ia32_l_FloattoLL,
	iro_ia32_CvtSI2SD,
	iro_ia32_vfldpi,
	iro_ia32_XorMem,
	iro_ia32_vfsub,
	iro_ia32_CopyB,
	iro_ia32_Sar,
	iro_ia32_Div,
	iro_ia32_fpushCopy,
	iro_ia32_Stc,
	iro_ia32_Fucomi,
	iro_ia32_fldl2e,
	iro_ia32_Enter,
	iro_ia32_fmul,
	iro_ia32_l_IMul,
	iro_ia32_NoReg_XMM,
	iro_ia32_xMax,
	iro_ia32_fdivrp,
	iro_ia32_OrMem8Bit,
	iro_ia32_fsub,
	iro_ia32_Lea,
	iro_ia32_FtstFnstsw,
	iro_ia32_NotMem,
	iro_ia32_vFucomi,
	iro_ia32_Bt,
	iro_ia32_vfabs,
	iro_ia32_Or,
	iro_ia32_Xor,
	iro_ia32_CopyB_i,
	iro_ia32_IncMem,
	iro_ia32_xAllOnes,
	iro_ia32_ffreep,
	iro_ia32_vfldlg2,
	iro_ia32_SubMem,
	iro_ia32_vfisttp,
	iro_ia32_AddMem,
	iro_ia32_ShlMem,
	iro_ia32_Fucompi,
	iro_ia32_fdiv,
	iro_ia32_vfldl2e,
	iro_ia32_xMin,
	iro_ia32_fist,
	iro_ia32_xXor,
	iro_ia32_IJmp,
	iro_ia32_NegMem,
	iro_ia32_Mul,
	iro_ia32_Sahf,
	iro_ia32_vfld1,
	iro_ia32_SubMem8Bit,
	iro_ia32_AddMem8Bit,
	iro_ia32_fst,
	iro_ia32_vfadd,
	iro_ia32_FucomppFnstsw,
	iro_ia32_vfld,
	iro_ia32_vfchs,
	iro_ia32_RorMem,
	iro_ia32_fpush,
	iro_ia32_fild,
	iro_ia32_xOr,
	iro_ia32_Conv_I2I8Bit,
	iro_ia32_Store,
	iro_ia32_fldln2,
	iro_ia32_SwitchJmp,
	iro_ia32_IMul,
	iro_ia32_l_ShrD,
	iro_ia32_Ucomi,
	iro_ia32_CMov,
	iro_ia32_fldz,
	iro_ia32_Unknown_GP,
	iro_ia32_Store8Bit,
	iro_ia32_fpop,
	iro_ia32_l_Sub,
	iro_ia32_Sbb,
	iro_ia32_FucomFnstsw,
	iro_ia32_Set,
	iro_ia32_fdivp,
	iro_ia32_fmulp,
	iro_ia32_xMul,
	iro_ia32_Push,
	iro_ia32_fsubrp,
	iro_ia32_xPslld,
	iro_ia32_Cmp,
	iro_ia32_FucompFnstsw,
	iro_ia32_mov_gp_variant0,
	iro_ia32_vfldl2t,
	iro_ia32_xSub,
	iro_ia32_vfst,
	iro_ia32_xMovd,
	iro_ia32_Cltd,
	iro_ia32_xPsrld,
	iro_ia32_xPzero,
	iro_ia32_Rol,
	iro_ia32_Cmc,
	iro_ia32_Cmp8Bit,
	iro_ia32_xDiv,
	iro_ia32_Test8Bit,
	iro_ia32_Sub,
	iro_ia32_Shr,
	iro_ia32_fprem,
	iro_ia32_IDiv,
	iro_ia32_l_Adc,
	iro_ia32_l_LLtoFloat,
	iro_ia32_vfldz,
	iro_ia32_ProduceVal,
	iro_ia32_vFucomFnstsw,
	iro_ia32_Test,
	iro_ia32_l_Add,
	iro_ia32_AddSP,
	iro_ia32_fsubr,
	iro_ia32_RolMem,
	iro_ia32_Conv_I2FP,
	iro_ia32_Conv_FP2FP,
	iro_ia32_ChangeCW,
	iro_ia32_NoReg_GP,
	iro_ia32_Const,
	iro_ia32_Minus64Bit,
	iro_ia32_FnstCW,
	iro_ia32_vfild,
	iro_ia32_OrMem,
	iro_ia32_fsubp,
	iro_ia32_fldlg2,
	iro_ia32_vfldln2,
	iro_ia32_fld1,
	iro_ia32_Conv_FP2I,
	iro_ia32_Ror,
	iro_ia32_fpremp,
	iro_ia32_Shl,
	iro_ia32_AndMem8Bit,
	iro_ia32_fistp,
	iro_ia32_Add,
	iro_ia32_SubSP,
	iro_ia32_Conv_I2I,
	iro_ia32_fxch,
	iro_ia32_fchs,
	iro_ia32_ShrD,
	iro_ia32_fstp,
	iro_ia32_l_SarDep,
	iro_ia32_vfmul,
	iro_ia32_vfist,
	iro_ia32_Cwtl,
	iro_ia32_fabs,
	iro_ia32_vfdiv,
	iro_ia32_Unknown_XMM,
	iro_ia32_fldpi,
	iro_ia32_Leave,
	iro_ia32_NoReg_VFP,
	iro_ia32_Neg,
	iro_ia32_IMul1OP,
	iro_ia32_PopMem,
	iro_ia32_fld,
	iro_ia32_Dec,
	iro_ia32_Pop,
	iro_ia32_faddp,
	iro_ia32_Not,
	iro_ia32_l_ShrDep,
	iro_ia32_AndMem,
	iro_ia32_femms,
	iro_ia32_xStoreSimple,
	iro_ia32_And,
	iro_ia32_Jcc,
	iro_ia32_SetMem,
	iro_ia32_Asm,
	iro_ia32_l_Sbb,
	iro_ia32_SarMem,
	iro_ia32_RepPrefix,
	iro_ia32_Adc,
	iro_ia32_l_ShlDep,
	iro_ia32_l_Mul,
	iro_ia32_xAndNot,
	iro_ia32_Load,
	iro_ia32_last_generated,
	iro_ia32_last = iro_ia32_last_generated
} ia32_opcodes;

int is_ia32_irn(const ir_node *node);

int get_ia32_opcode_first(void);
int get_ia32_opcode_last(void);
int get_ia32_irn_opcode(const ir_node *node);
void ia32_create_opcodes(const arch_irn_ops_t *be_ops);
extern ir_op *op_ia32_xZero;
ir_op *get_op_ia32_xZero(void);
int is_ia32_xZero(const ir_node *n);
/**
 * construct xZero node
 */
ir_node *new_bd_ia32_xZero(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_FldCW;
ir_op *get_op_ia32_FldCW(void);
int is_ia32_FldCW(const ir_node *n);
/**
 * construct FldCW node
 */
ir_node *new_bd_ia32_FldCW(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem);

extern ir_op *op_ia32_fadd;
ir_op *get_op_ia32_fadd(void);
int is_ia32_fadd(const ir_node *n);

extern ir_op *op_ia32_ShrMem;
ir_op *get_op_ia32_ShrMem(void);
int is_ia32_ShrMem(const ir_node *n);
/**
 * construct ShrMem node
 */
ir_node *new_bd_ia32_ShrMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *count);

extern ir_op *op_ia32_Immediate;
ir_op *get_op_ia32_Immediate(void);
int is_ia32_Immediate(const ir_node *n);
/**
 * construct Immediate node
 */
ir_node *new_bd_ia32_Immediate(dbg_info *db, ir_node *block, ir_entity *symconst, int symconst_sign, long offset);

extern ir_op *op_ia32_CvtSI2SS;
ir_op *get_op_ia32_CvtSI2SS(void);
int is_ia32_CvtSI2SS(const ir_node *n);
/**
 * construct CvtSI2SS node
 */
ir_node *new_bd_ia32_CvtSI2SS(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_LdTls;
ir_op *get_op_ia32_LdTls(void);
int is_ia32_LdTls(const ir_node *n);
/**
 * construct LdTls node
 */
ir_node *new_bd_ia32_LdTls(dbg_info *db, ir_node *block, ir_mode *mode);

extern ir_op *op_ia32_ShlD;
ir_op *get_op_ia32_ShlD(void);
int is_ia32_ShlD(const ir_node *n);
/**
 * construct ShlD node
 */
ir_node *new_bd_ia32_ShlD(dbg_info *db, ir_node *block, ir_node *val_high, ir_node *val_low, ir_node *count);

extern ir_op *op_ia32_PopEbp;
ir_op *get_op_ia32_PopEbp(void);
int is_ia32_PopEbp(const ir_node *n);
/**
 * construct PopEbp node
 */
ir_node *new_bd_ia32_PopEbp(dbg_info *db, ir_node *block, ir_node *mem, ir_node *stack);

extern ir_op *op_ia32_Inc;
ir_op *get_op_ia32_Inc(void);
int is_ia32_Inc(const ir_node *n);
/**
 * construct Inc node
 */
ir_node *new_bd_ia32_Inc(dbg_info *db, ir_node *block, ir_node *val);

extern ir_op *op_ia32_xStore;
ir_op *get_op_ia32_xStore(void);
int is_ia32_xStore(const ir_node *n);
/**
 * construct xStore node
 */
ir_node *new_bd_ia32_xStore(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_l_ShlD;
ir_op *get_op_ia32_l_ShlD(void);
int is_ia32_l_ShlD(const ir_node *n);
/**
 * construct l_ShlD node
 */
ir_node *new_bd_ia32_l_ShlD(dbg_info *db, ir_node *block, ir_node *val_high, ir_node *val_low, ir_node *count, ir_mode *mode);

extern ir_op *op_ia32_xxLoad;
ir_op *get_op_ia32_xxLoad(void);
int is_ia32_xxLoad(const ir_node *n);
/**
 * construct xxLoad node
 */
ir_node *new_bd_ia32_xxLoad(dbg_info *db, ir_node *block, ir_node *op0, ir_node *op1, ir_node *op2);

extern ir_op *op_ia32_xAnd;
ir_op *get_op_ia32_xAnd(void);
int is_ia32_xAnd(const ir_node *n);
/**
 * construct xAnd node
 */
ir_node *new_bd_ia32_xAnd(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_GetEIP;
ir_op *get_op_ia32_GetEIP(void);
int is_ia32_GetEIP(const ir_node *n);
/**
 * construct GetEIP node
 */
ir_node *new_bd_ia32_GetEIP(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_xAdd;
ir_op *get_op_ia32_xAdd(void);
int is_ia32_xAdd(const ir_node *n);
/**
 * construct xAdd node
 */
ir_node *new_bd_ia32_xAdd(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_xPsllq;
ir_op *get_op_ia32_xPsllq(void);
int is_ia32_xPsllq(const ir_node *n);
/**
 * construct xPsllq node
 */
ir_node *new_bd_ia32_xPsllq(dbg_info *db, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_ia32_xxStore;
ir_op *get_op_ia32_xxStore(void);
int is_ia32_xxStore(const ir_node *n);
/**
 * construct xxStore node
 */
ir_node *new_bd_ia32_xxStore(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_Call;
ir_op *get_op_ia32_Call(void);
int is_ia32_Call(const ir_node *n);
/**
 * construct Call node
 */
ir_node *new_bd_ia32_Call(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *addr, ir_node *stack, ir_node *fpcw, ir_node *eax, ir_node *ecx, ir_node *edx, unsigned pop, ir_type *call_tp);

extern ir_op *op_ia32_FnstCWNOP;
ir_op *get_op_ia32_FnstCWNOP(void);
int is_ia32_FnstCWNOP(const ir_node *n);
/**
 * construct FnstCWNOP node
 */
ir_node *new_bd_ia32_FnstCWNOP(dbg_info *db, ir_node *block, ir_node *fpcw);

extern ir_op *op_ia32_vFtstFnstsw;
ir_op *get_op_ia32_vFtstFnstsw(void);
int is_ia32_vFtstFnstsw(const ir_node *n);
/**
 * construct vFtstFnstsw node
 */
ir_node *new_bd_ia32_vFtstFnstsw(dbg_info *db, ir_node *block, ir_node *left, int ins_permuted);

extern ir_op *op_ia32_XorMem8Bit;
ir_op *get_op_ia32_XorMem8Bit(void);
int is_ia32_XorMem8Bit(const ir_node *n);
/**
 * construct XorMem8Bit node
 */
ir_node *new_bd_ia32_XorMem8Bit(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_fldl2t;
ir_op *get_op_ia32_fldl2t(void);
int is_ia32_fldl2t(const ir_node *n);
/**
 * construct fldl2t node
 */
ir_node *new_bd_ia32_fldl2t(dbg_info *db, ir_node *block, ir_mode *mode);

extern ir_op *op_ia32_fisttp;
ir_op *get_op_ia32_fisttp(void);
int is_ia32_fisttp(const ir_node *n);

extern ir_op *op_ia32_DecMem;
ir_op *get_op_ia32_DecMem(void);
int is_ia32_DecMem(const ir_node *n);
/**
 * construct DecMem node
 */
ir_node *new_bd_ia32_DecMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem);

extern ir_op *op_ia32_emms;
ir_op *get_op_ia32_emms(void);
int is_ia32_emms(const ir_node *n);
/**
 * construct emms node
 */
ir_node *new_bd_ia32_emms(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_fdivr;
ir_op *get_op_ia32_fdivr(void);
int is_ia32_fdivr(const ir_node *n);

extern ir_op *op_ia32_Unknown_VFP;
ir_op *get_op_ia32_Unknown_VFP(void);
int is_ia32_Unknown_VFP(const ir_node *n);
/**
 * construct Unknown_VFP node
 */
ir_node *new_bd_ia32_Unknown_VFP(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_vfprem;
ir_op *get_op_ia32_vfprem(void);
int is_ia32_vfprem(const ir_node *n);
/**
 * construct vfprem node
 */
ir_node *new_bd_ia32_vfprem(dbg_info *db, ir_node *block, ir_node *left, ir_node *right, ir_node *fpcw);

extern ir_op *op_ia32_xLoad;
ir_op *get_op_ia32_xLoad(void);
int is_ia32_xLoad(const ir_node *n);
/**
 * construct xLoad node
 */
ir_node *new_bd_ia32_xLoad(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_mode *load_mode);

extern ir_op *op_ia32_l_FloattoLL;
ir_op *get_op_ia32_l_FloattoLL(void);
int is_ia32_l_FloattoLL(const ir_node *n);
/**
 * construct l_FloattoLL node
 */
ir_node *new_bd_ia32_l_FloattoLL(dbg_info *db, ir_node *block, ir_node *val);

extern ir_op *op_ia32_CvtSI2SD;
ir_op *get_op_ia32_CvtSI2SD(void);
int is_ia32_CvtSI2SD(const ir_node *n);
/**
 * construct CvtSI2SD node
 */
ir_node *new_bd_ia32_CvtSI2SD(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_vfldpi;
ir_op *get_op_ia32_vfldpi(void);
int is_ia32_vfldpi(const ir_node *n);
/**
 * construct vfldpi node
 */
ir_node *new_bd_ia32_vfldpi(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_XorMem;
ir_op *get_op_ia32_XorMem(void);
int is_ia32_XorMem(const ir_node *n);
/**
 * construct XorMem node
 */
ir_node *new_bd_ia32_XorMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_vfsub;
ir_op *get_op_ia32_vfsub(void);
int is_ia32_vfsub(const ir_node *n);
/**
 * construct vfsub node
 */
ir_node *new_bd_ia32_vfsub(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *minuend, ir_node *subtrahend, ir_node *fpcw);

extern ir_op *op_ia32_CopyB;
ir_op *get_op_ia32_CopyB(void);
int is_ia32_CopyB(const ir_node *n);
/**
 * construct CopyB node
 */
ir_node *new_bd_ia32_CopyB(dbg_info *db, ir_node *block, ir_node *op0, ir_node *op1, ir_node *op2, ir_node *op3, unsigned size);

extern ir_op *op_ia32_Sar;
ir_op *get_op_ia32_Sar(void);
int is_ia32_Sar(const ir_node *n);
/**
 * construct Sar node
 */
ir_node *new_bd_ia32_Sar(dbg_info *db, ir_node *block, ir_node *val, ir_node *count);

extern ir_op *op_ia32_Div;
ir_op *get_op_ia32_Div(void);
int is_ia32_Div(const ir_node *n);
/**
 * construct Div node
 */
ir_node *new_bd_ia32_Div(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *divisor, ir_node *dividend_low, ir_node *dividend_high);

extern ir_op *op_ia32_fpushCopy;
ir_op *get_op_ia32_fpushCopy(void);
int is_ia32_fpushCopy(const ir_node *n);
/**
 * construct fpushCopy node
 */
ir_node *new_bd_ia32_fpushCopy(dbg_info *db, ir_node *block, ir_node *op0, ir_mode *mode);

extern ir_op *op_ia32_Stc;
ir_op *get_op_ia32_Stc(void);
int is_ia32_Stc(const ir_node *n);
/**
 * construct Stc node
 */
ir_node *new_bd_ia32_Stc(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_Fucomi;
ir_op *get_op_ia32_Fucomi(void);
int is_ia32_Fucomi(const ir_node *n);
/**
 * construct Fucomi node
 */
ir_node *new_bd_ia32_Fucomi(dbg_info *db, ir_node *block, ir_mode *mode);

extern ir_op *op_ia32_fldl2e;
ir_op *get_op_ia32_fldl2e(void);
int is_ia32_fldl2e(const ir_node *n);
/**
 * construct fldl2e node
 */
ir_node *new_bd_ia32_fldl2e(dbg_info *db, ir_node *block, ir_mode *mode);

extern ir_op *op_ia32_Enter;
ir_op *get_op_ia32_Enter(void);
int is_ia32_Enter(const ir_node *n);
/**
 * construct Enter node
 */
ir_node *new_bd_ia32_Enter(dbg_info *db, ir_node *block, ir_node *op0);

extern ir_op *op_ia32_fmul;
ir_op *get_op_ia32_fmul(void);
int is_ia32_fmul(const ir_node *n);

extern ir_op *op_ia32_l_IMul;
ir_op *get_op_ia32_l_IMul(void);
int is_ia32_l_IMul(const ir_node *n);
/**
 * construct l_IMul node
 */
ir_node *new_bd_ia32_l_IMul(dbg_info *db, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_ia32_NoReg_XMM;
ir_op *get_op_ia32_NoReg_XMM(void);
int is_ia32_NoReg_XMM(const ir_node *n);
/**
 * construct NoReg_XMM node
 */
ir_node *new_bd_ia32_NoReg_XMM(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_xMax;
ir_op *get_op_ia32_xMax(void);
int is_ia32_xMax(const ir_node *n);
/**
 * construct xMax node
 */
ir_node *new_bd_ia32_xMax(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_fdivrp;
ir_op *get_op_ia32_fdivrp(void);
int is_ia32_fdivrp(const ir_node *n);

extern ir_op *op_ia32_OrMem8Bit;
ir_op *get_op_ia32_OrMem8Bit(void);
int is_ia32_OrMem8Bit(const ir_node *n);
/**
 * construct OrMem8Bit node
 */
ir_node *new_bd_ia32_OrMem8Bit(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_fsub;
ir_op *get_op_ia32_fsub(void);
int is_ia32_fsub(const ir_node *n);

extern ir_op *op_ia32_Lea;
ir_op *get_op_ia32_Lea(void);
int is_ia32_Lea(const ir_node *n);
/**
 * construct Lea node
 */
ir_node *new_bd_ia32_Lea(dbg_info *db, ir_node *block, ir_node *base, ir_node *index);

extern ir_op *op_ia32_FtstFnstsw;
ir_op *get_op_ia32_FtstFnstsw(void);
int is_ia32_FtstFnstsw(const ir_node *n);
/**
 * construct FtstFnstsw node
 */
ir_node *new_bd_ia32_FtstFnstsw(dbg_info *db, ir_node *block, ir_mode *mode);

extern ir_op *op_ia32_NotMem;
ir_op *get_op_ia32_NotMem(void);
int is_ia32_NotMem(const ir_node *n);
/**
 * construct NotMem node
 */
ir_node *new_bd_ia32_NotMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem);

extern ir_op *op_ia32_vFucomi;
ir_op *get_op_ia32_vFucomi(void);
int is_ia32_vFucomi(const ir_node *n);
/**
 * construct vFucomi node
 */
ir_node *new_bd_ia32_vFucomi(dbg_info *db, ir_node *block, ir_node *left, ir_node *right, int ins_permuted);

extern ir_op *op_ia32_Bt;
ir_op *get_op_ia32_Bt(void);
int is_ia32_Bt(const ir_node *n);
/**
 * construct Bt node
 */
ir_node *new_bd_ia32_Bt(dbg_info *db, ir_node *block, ir_node *left, ir_node *right);

extern ir_op *op_ia32_vfabs;
ir_op *get_op_ia32_vfabs(void);
int is_ia32_vfabs(const ir_node *n);
/**
 * construct vfabs node
 */
ir_node *new_bd_ia32_vfabs(dbg_info *db, ir_node *block, ir_node *value);

extern ir_op *op_ia32_Or;
ir_op *get_op_ia32_Or(void);
int is_ia32_Or(const ir_node *n);
/**
 * construct Or node
 */
ir_node *new_bd_ia32_Or(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_Xor;
ir_op *get_op_ia32_Xor(void);
int is_ia32_Xor(const ir_node *n);
/**
 * construct Xor node
 */
ir_node *new_bd_ia32_Xor(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_CopyB_i;
ir_op *get_op_ia32_CopyB_i(void);
int is_ia32_CopyB_i(const ir_node *n);
/**
 * construct CopyB_i node
 */
ir_node *new_bd_ia32_CopyB_i(dbg_info *db, ir_node *block, ir_node *op0, ir_node *op1, ir_node *op2, unsigned size);

extern ir_op *op_ia32_IncMem;
ir_op *get_op_ia32_IncMem(void);
int is_ia32_IncMem(const ir_node *n);
/**
 * construct IncMem node
 */
ir_node *new_bd_ia32_IncMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem);

extern ir_op *op_ia32_xAllOnes;
ir_op *get_op_ia32_xAllOnes(void);
int is_ia32_xAllOnes(const ir_node *n);
/**
 * construct xAllOnes node
 */
ir_node *new_bd_ia32_xAllOnes(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_ffreep;
ir_op *get_op_ia32_ffreep(void);
int is_ia32_ffreep(const ir_node *n);
/**
 * construct ffreep node
 */
ir_node *new_bd_ia32_ffreep(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_vfldlg2;
ir_op *get_op_ia32_vfldlg2(void);
int is_ia32_vfldlg2(const ir_node *n);
/**
 * construct vfldlg2 node
 */
ir_node *new_bd_ia32_vfldlg2(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_SubMem;
ir_op *get_op_ia32_SubMem(void);
int is_ia32_SubMem(const ir_node *n);
/**
 * construct SubMem node
 */
ir_node *new_bd_ia32_SubMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *subtrahend);

extern ir_op *op_ia32_vfisttp;
ir_op *get_op_ia32_vfisttp(void);
int is_ia32_vfisttp(const ir_node *n);
/**
 * construct vfisttp node
 */
ir_node *new_bd_ia32_vfisttp(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_AddMem;
ir_op *get_op_ia32_AddMem(void);
int is_ia32_AddMem(const ir_node *n);
/**
 * construct AddMem node
 */
ir_node *new_bd_ia32_AddMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_ShlMem;
ir_op *get_op_ia32_ShlMem(void);
int is_ia32_ShlMem(const ir_node *n);
/**
 * construct ShlMem node
 */
ir_node *new_bd_ia32_ShlMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *count);

extern ir_op *op_ia32_Fucompi;
ir_op *get_op_ia32_Fucompi(void);
int is_ia32_Fucompi(const ir_node *n);
/**
 * construct Fucompi node
 */
ir_node *new_bd_ia32_Fucompi(dbg_info *db, ir_node *block, ir_mode *mode);

extern ir_op *op_ia32_fdiv;
ir_op *get_op_ia32_fdiv(void);
int is_ia32_fdiv(const ir_node *n);

extern ir_op *op_ia32_vfldl2e;
ir_op *get_op_ia32_vfldl2e(void);
int is_ia32_vfldl2e(const ir_node *n);
/**
 * construct vfldl2e node
 */
ir_node *new_bd_ia32_vfldl2e(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_xMin;
ir_op *get_op_ia32_xMin(void);
int is_ia32_xMin(const ir_node *n);
/**
 * construct xMin node
 */
ir_node *new_bd_ia32_xMin(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_fist;
ir_op *get_op_ia32_fist(void);
int is_ia32_fist(const ir_node *n);

extern ir_op *op_ia32_xXor;
ir_op *get_op_ia32_xXor(void);
int is_ia32_xXor(const ir_node *n);
/**
 * construct xXor node
 */
ir_node *new_bd_ia32_xXor(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_IJmp;
ir_op *get_op_ia32_IJmp(void);
int is_ia32_IJmp(const ir_node *n);
/**
 * construct IJmp node
 */
ir_node *new_bd_ia32_IJmp(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *target);

extern ir_op *op_ia32_NegMem;
ir_op *get_op_ia32_NegMem(void);
int is_ia32_NegMem(const ir_node *n);
/**
 * construct NegMem node
 */
ir_node *new_bd_ia32_NegMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem);

extern ir_op *op_ia32_Mul;
ir_op *get_op_ia32_Mul(void);
int is_ia32_Mul(const ir_node *n);
/**
 * construct Mul node
 */
ir_node *new_bd_ia32_Mul(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_Sahf;
ir_op *get_op_ia32_Sahf(void);
int is_ia32_Sahf(const ir_node *n);
/**
 * construct Sahf node
 */
ir_node *new_bd_ia32_Sahf(dbg_info *db, ir_node *block, ir_node *val);

extern ir_op *op_ia32_vfld1;
ir_op *get_op_ia32_vfld1(void);
int is_ia32_vfld1(const ir_node *n);
/**
 * construct vfld1 node
 */
ir_node *new_bd_ia32_vfld1(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_SubMem8Bit;
ir_op *get_op_ia32_SubMem8Bit(void);
int is_ia32_SubMem8Bit(const ir_node *n);
/**
 * construct SubMem8Bit node
 */
ir_node *new_bd_ia32_SubMem8Bit(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *subtrahend);

extern ir_op *op_ia32_AddMem8Bit;
ir_op *get_op_ia32_AddMem8Bit(void);
int is_ia32_AddMem8Bit(const ir_node *n);
/**
 * construct AddMem8Bit node
 */
ir_node *new_bd_ia32_AddMem8Bit(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_fst;
ir_op *get_op_ia32_fst(void);
int is_ia32_fst(const ir_node *n);

extern ir_op *op_ia32_vfadd;
ir_op *get_op_ia32_vfadd(void);
int is_ia32_vfadd(const ir_node *n);
/**
 * construct vfadd node
 */
ir_node *new_bd_ia32_vfadd(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right, ir_node *fpcw);

extern ir_op *op_ia32_FucomppFnstsw;
ir_op *get_op_ia32_FucomppFnstsw(void);
int is_ia32_FucomppFnstsw(const ir_node *n);
/**
 * construct FucomppFnstsw node
 */
ir_node *new_bd_ia32_FucomppFnstsw(dbg_info *db, ir_node *block, ir_mode *mode);

extern ir_op *op_ia32_vfld;
ir_op *get_op_ia32_vfld(void);
int is_ia32_vfld(const ir_node *n);
/**
 * construct vfld node
 */
ir_node *new_bd_ia32_vfld(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_mode *load_mode);

extern ir_op *op_ia32_vfchs;
ir_op *get_op_ia32_vfchs(void);
int is_ia32_vfchs(const ir_node *n);
/**
 * construct vfchs node
 */
ir_node *new_bd_ia32_vfchs(dbg_info *db, ir_node *block, ir_node *value);

extern ir_op *op_ia32_RorMem;
ir_op *get_op_ia32_RorMem(void);
int is_ia32_RorMem(const ir_node *n);
/**
 * construct RorMem node
 */
ir_node *new_bd_ia32_RorMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *count);

extern ir_op *op_ia32_fpush;
ir_op *get_op_ia32_fpush(void);
int is_ia32_fpush(const ir_node *n);
/**
 * construct fpush node
 */
ir_node *new_bd_ia32_fpush(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_fild;
ir_op *get_op_ia32_fild(void);
int is_ia32_fild(const ir_node *n);

extern ir_op *op_ia32_xOr;
ir_op *get_op_ia32_xOr(void);
int is_ia32_xOr(const ir_node *n);
/**
 * construct xOr node
 */
ir_node *new_bd_ia32_xOr(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_Conv_I2I8Bit;
ir_op *get_op_ia32_Conv_I2I8Bit(void);
int is_ia32_Conv_I2I8Bit(const ir_node *n);
/**
 * construct Conv_I2I8Bit node
 */
ir_node *new_bd_ia32_Conv_I2I8Bit(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val, ir_mode *smaller_mode);

extern ir_op *op_ia32_Store;
ir_op *get_op_ia32_Store(void);
int is_ia32_Store(const ir_node *n);
/**
 * construct Store node
 */
ir_node *new_bd_ia32_Store(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_fldln2;
ir_op *get_op_ia32_fldln2(void);
int is_ia32_fldln2(const ir_node *n);
/**
 * construct fldln2 node
 */
ir_node *new_bd_ia32_fldln2(dbg_info *db, ir_node *block, ir_mode *mode);

extern ir_op *op_ia32_SwitchJmp;
ir_op *get_op_ia32_SwitchJmp(void);
int is_ia32_SwitchJmp(const ir_node *n);
/**
 * construct SwitchJmp node
 */
ir_node *new_bd_ia32_SwitchJmp(dbg_info *db, ir_node *block, ir_node *op0, long pnc);

extern ir_op *op_ia32_IMul;
ir_op *get_op_ia32_IMul(void);
int is_ia32_IMul(const ir_node *n);
/**
 * construct IMul node
 */
ir_node *new_bd_ia32_IMul(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_l_ShrD;
ir_op *get_op_ia32_l_ShrD(void);
int is_ia32_l_ShrD(const ir_node *n);
/**
 * construct l_ShrD node
 */
ir_node *new_bd_ia32_l_ShrD(dbg_info *db, ir_node *block, ir_node *val_high, ir_node *val_low, ir_node *count, ir_mode *mode);

extern ir_op *op_ia32_Ucomi;
ir_op *get_op_ia32_Ucomi(void);
int is_ia32_Ucomi(const ir_node *n);
/**
 * construct Ucomi node
 */
ir_node *new_bd_ia32_Ucomi(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right, int ins_permuted);

extern ir_op *op_ia32_CMov;
ir_op *get_op_ia32_CMov(void);
int is_ia32_CMov(const ir_node *n);
/**
 * construct CMov node
 */
ir_node *new_bd_ia32_CMov(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val_false, ir_node *val_true, ir_node *eflags, int ins_permuted, pn_Cmp pnc);

extern ir_op *op_ia32_fldz;
ir_op *get_op_ia32_fldz(void);
int is_ia32_fldz(const ir_node *n);
/**
 * construct fldz node
 */
ir_node *new_bd_ia32_fldz(dbg_info *db, ir_node *block, ir_mode *mode);

extern ir_op *op_ia32_Unknown_GP;
ir_op *get_op_ia32_Unknown_GP(void);
int is_ia32_Unknown_GP(const ir_node *n);
/**
 * construct Unknown_GP node
 */
ir_node *new_bd_ia32_Unknown_GP(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_Store8Bit;
ir_op *get_op_ia32_Store8Bit(void);
int is_ia32_Store8Bit(const ir_node *n);
/**
 * construct Store8Bit node
 */
ir_node *new_bd_ia32_Store8Bit(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_fpop;
ir_op *get_op_ia32_fpop(void);
int is_ia32_fpop(const ir_node *n);
/**
 * construct fpop node
 */
ir_node *new_bd_ia32_fpop(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_l_Sub;
ir_op *get_op_ia32_l_Sub(void);
int is_ia32_l_Sub(const ir_node *n);
/**
 * construct l_Sub node
 */
ir_node *new_bd_ia32_l_Sub(dbg_info *db, ir_node *block, ir_node *minuend, ir_node *subtrahend, ir_mode *mode);

extern ir_op *op_ia32_Sbb;
ir_op *get_op_ia32_Sbb(void);
int is_ia32_Sbb(const ir_node *n);
/**
 * construct Sbb node
 */
ir_node *new_bd_ia32_Sbb(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *minuend, ir_node *subtrahend, ir_node *eflags);

extern ir_op *op_ia32_FucomFnstsw;
ir_op *get_op_ia32_FucomFnstsw(void);
int is_ia32_FucomFnstsw(const ir_node *n);
/**
 * construct FucomFnstsw node
 */
ir_node *new_bd_ia32_FucomFnstsw(dbg_info *db, ir_node *block, ir_mode *mode);

extern ir_op *op_ia32_Set;
ir_op *get_op_ia32_Set(void);
int is_ia32_Set(const ir_node *n);
/**
 * construct Set node
 */
ir_node *new_bd_ia32_Set(dbg_info *db, ir_node *block, ir_node *eflags, pn_Cmp pnc, int ins_permuted);

extern ir_op *op_ia32_fdivp;
ir_op *get_op_ia32_fdivp(void);
int is_ia32_fdivp(const ir_node *n);

extern ir_op *op_ia32_fmulp;
ir_op *get_op_ia32_fmulp(void);
int is_ia32_fmulp(const ir_node *n);

extern ir_op *op_ia32_xMul;
ir_op *get_op_ia32_xMul(void);
int is_ia32_xMul(const ir_node *n);
/**
 * construct xMul node
 */
ir_node *new_bd_ia32_xMul(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_Push;
ir_op *get_op_ia32_Push(void);
int is_ia32_Push(const ir_node *n);
/**
 * construct Push node
 */
ir_node *new_bd_ia32_Push(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val, ir_node *stack);

extern ir_op *op_ia32_fsubrp;
ir_op *get_op_ia32_fsubrp(void);
int is_ia32_fsubrp(const ir_node *n);

extern ir_op *op_ia32_xPslld;
ir_op *get_op_ia32_xPslld(void);
int is_ia32_xPslld(const ir_node *n);
/**
 * construct xPslld node
 */
ir_node *new_bd_ia32_xPslld(dbg_info *db, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_ia32_Cmp;
ir_op *get_op_ia32_Cmp(void);
int is_ia32_Cmp(const ir_node *n);
/**
 * construct Cmp node
 */
ir_node *new_bd_ia32_Cmp(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right, int ins_permuted, int cmp_unsigned);

extern ir_op *op_ia32_FucompFnstsw;
ir_op *get_op_ia32_FucompFnstsw(void);
int is_ia32_FucompFnstsw(const ir_node *n);
/**
 * construct FucompFnstsw node
 */
ir_node *new_bd_ia32_FucompFnstsw(dbg_info *db, ir_node *block, ir_mode *mode);

extern ir_op *op_ia32_mov_gp_variant0;
ir_op *get_op_ia32_mov_gp_variant0(void);
int is_ia32_mov_gp_variant0(const ir_node *n);
/**
 * construct mov_gp_variant0 node
 */
ir_node *new_bd_ia32_mov_gp_variant0(dbg_info *db, ir_node *block, ir_node *op0, ir_mode *mode);

extern ir_op *op_ia32_vfldl2t;
ir_op *get_op_ia32_vfldl2t(void);
int is_ia32_vfldl2t(const ir_node *n);
/**
 * construct vfldl2t node
 */
ir_node *new_bd_ia32_vfldl2t(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_xSub;
ir_op *get_op_ia32_xSub(void);
int is_ia32_xSub(const ir_node *n);
/**
 * construct xSub node
 */
ir_node *new_bd_ia32_xSub(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *minuend, ir_node *subtrahend);

extern ir_op *op_ia32_vfst;
ir_op *get_op_ia32_vfst(void);
int is_ia32_vfst(const ir_node *n);
/**
 * construct vfst node
 */
ir_node *new_bd_ia32_vfst(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val, ir_mode *store_mode);

extern ir_op *op_ia32_xMovd;
ir_op *get_op_ia32_xMovd(void);
int is_ia32_xMovd(const ir_node *n);
/**
 * construct xMovd node
 */
ir_node *new_bd_ia32_xMovd(dbg_info *db, ir_node *block, ir_node *op0);

extern ir_op *op_ia32_Cltd;
ir_op *get_op_ia32_Cltd(void);
int is_ia32_Cltd(const ir_node *n);
/**
 * construct Cltd node
 */
ir_node *new_bd_ia32_Cltd(dbg_info *db, ir_node *block, ir_node *val, ir_node *clobbered);

extern ir_op *op_ia32_xPsrld;
ir_op *get_op_ia32_xPsrld(void);
int is_ia32_xPsrld(const ir_node *n);
/**
 * construct xPsrld node
 */
ir_node *new_bd_ia32_xPsrld(dbg_info *db, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_ia32_xPzero;
ir_op *get_op_ia32_xPzero(void);
int is_ia32_xPzero(const ir_node *n);
/**
 * construct xPzero node
 */
ir_node *new_bd_ia32_xPzero(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_Rol;
ir_op *get_op_ia32_Rol(void);
int is_ia32_Rol(const ir_node *n);
/**
 * construct Rol node
 */
ir_node *new_bd_ia32_Rol(dbg_info *db, ir_node *block, ir_node *val, ir_node *count);

extern ir_op *op_ia32_Cmc;
ir_op *get_op_ia32_Cmc(void);
int is_ia32_Cmc(const ir_node *n);
/**
 * construct Cmc node
 */
ir_node *new_bd_ia32_Cmc(dbg_info *db, ir_node *block, ir_node *op0);

extern ir_op *op_ia32_Cmp8Bit;
ir_op *get_op_ia32_Cmp8Bit(void);
int is_ia32_Cmp8Bit(const ir_node *n);
/**
 * construct Cmp8Bit node
 */
ir_node *new_bd_ia32_Cmp8Bit(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right, int ins_permuted, int cmp_unsigned);

extern ir_op *op_ia32_xDiv;
ir_op *get_op_ia32_xDiv(void);
int is_ia32_xDiv(const ir_node *n);
/**
 * construct xDiv node
 */
ir_node *new_bd_ia32_xDiv(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *dividend, ir_node *divisor);

extern ir_op *op_ia32_Test8Bit;
ir_op *get_op_ia32_Test8Bit(void);
int is_ia32_Test8Bit(const ir_node *n);
/**
 * construct Test8Bit node
 */
ir_node *new_bd_ia32_Test8Bit(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right, int ins_permuted, int cmp_unsigned);

extern ir_op *op_ia32_Sub;
ir_op *get_op_ia32_Sub(void);
int is_ia32_Sub(const ir_node *n);
/**
 * construct Sub node
 */
ir_node *new_bd_ia32_Sub(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *minuend, ir_node *subtrahend);

extern ir_op *op_ia32_Shr;
ir_op *get_op_ia32_Shr(void);
int is_ia32_Shr(const ir_node *n);
/**
 * construct Shr node
 */
ir_node *new_bd_ia32_Shr(dbg_info *db, ir_node *block, ir_node *val, ir_node *count);

extern ir_op *op_ia32_fprem;
ir_op *get_op_ia32_fprem(void);
int is_ia32_fprem(const ir_node *n);

extern ir_op *op_ia32_IDiv;
ir_op *get_op_ia32_IDiv(void);
int is_ia32_IDiv(const ir_node *n);
/**
 * construct IDiv node
 */
ir_node *new_bd_ia32_IDiv(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *divisor, ir_node *dividend_low, ir_node *dividend_high);

extern ir_op *op_ia32_l_Adc;
ir_op *get_op_ia32_l_Adc(void);
int is_ia32_l_Adc(const ir_node *n);
/**
 * construct l_Adc node
 */
ir_node *new_bd_ia32_l_Adc(dbg_info *db, ir_node *block, ir_node *left, ir_node *right, ir_node *eflags, ir_mode *mode);

extern ir_op *op_ia32_l_LLtoFloat;
ir_op *get_op_ia32_l_LLtoFloat(void);
int is_ia32_l_LLtoFloat(const ir_node *n);
/**
 * construct l_LLtoFloat node
 */
ir_node *new_bd_ia32_l_LLtoFloat(dbg_info *db, ir_node *block, ir_node *val_high, ir_node *val_low, ir_mode *mode);

extern ir_op *op_ia32_vfldz;
ir_op *get_op_ia32_vfldz(void);
int is_ia32_vfldz(const ir_node *n);
/**
 * construct vfldz node
 */
ir_node *new_bd_ia32_vfldz(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_ProduceVal;
ir_op *get_op_ia32_ProduceVal(void);
int is_ia32_ProduceVal(const ir_node *n);
/**
 * construct ProduceVal node
 */
ir_node *new_bd_ia32_ProduceVal(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_vFucomFnstsw;
ir_op *get_op_ia32_vFucomFnstsw(void);
int is_ia32_vFucomFnstsw(const ir_node *n);
/**
 * construct vFucomFnstsw node
 */
ir_node *new_bd_ia32_vFucomFnstsw(dbg_info *db, ir_node *block, ir_node *left, ir_node *right, int ins_permuted);

extern ir_op *op_ia32_Test;
ir_op *get_op_ia32_Test(void);
int is_ia32_Test(const ir_node *n);
/**
 * construct Test node
 */
ir_node *new_bd_ia32_Test(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right, int ins_permuted, int cmp_unsigned);

extern ir_op *op_ia32_l_Add;
ir_op *get_op_ia32_l_Add(void);
int is_ia32_l_Add(const ir_node *n);
/**
 * construct l_Add node
 */
ir_node *new_bd_ia32_l_Add(dbg_info *db, ir_node *block, ir_node *left, ir_node *right, ir_mode *mode);

extern ir_op *op_ia32_AddSP;
ir_op *get_op_ia32_AddSP(void);
int is_ia32_AddSP(const ir_node *n);
/**
 * construct AddSP node
 */
ir_node *new_bd_ia32_AddSP(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *stack, ir_node *size);

extern ir_op *op_ia32_fsubr;
ir_op *get_op_ia32_fsubr(void);
int is_ia32_fsubr(const ir_node *n);

extern ir_op *op_ia32_RolMem;
ir_op *get_op_ia32_RolMem(void);
int is_ia32_RolMem(const ir_node *n);
/**
 * construct RolMem node
 */
ir_node *new_bd_ia32_RolMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *count);

extern ir_op *op_ia32_Conv_I2FP;
ir_op *get_op_ia32_Conv_I2FP(void);
int is_ia32_Conv_I2FP(const ir_node *n);
/**
 * construct Conv_I2FP node
 */
ir_node *new_bd_ia32_Conv_I2FP(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_Conv_FP2FP;
ir_op *get_op_ia32_Conv_FP2FP(void);
int is_ia32_Conv_FP2FP(const ir_node *n);
/**
 * construct Conv_FP2FP node
 */
ir_node *new_bd_ia32_Conv_FP2FP(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_ChangeCW;
ir_op *get_op_ia32_ChangeCW(void);
int is_ia32_ChangeCW(const ir_node *n);
/**
 * construct ChangeCW node
 */
ir_node *new_bd_ia32_ChangeCW(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_NoReg_GP;
ir_op *get_op_ia32_NoReg_GP(void);
int is_ia32_NoReg_GP(const ir_node *n);
/**
 * construct NoReg_GP node
 */
ir_node *new_bd_ia32_NoReg_GP(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_Const;
ir_op *get_op_ia32_Const(void);
int is_ia32_Const(const ir_node *n);
/**
 * construct Const node
 */
ir_node *new_bd_ia32_Const(dbg_info *db, ir_node *block, ir_entity *symconst, int symconst_sign, long offset);

extern ir_op *op_ia32_Minus64Bit;
ir_op *get_op_ia32_Minus64Bit(void);
int is_ia32_Minus64Bit(const ir_node *n);
/**
 * construct Minus64Bit node
 */
ir_node *new_bd_ia32_Minus64Bit(dbg_info *db, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_ia32_FnstCW;
ir_op *get_op_ia32_FnstCW(void);
int is_ia32_FnstCW(const ir_node *n);
/**
 * construct FnstCW node
 */
ir_node *new_bd_ia32_FnstCW(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *fpcw);

extern ir_op *op_ia32_vfild;
ir_op *get_op_ia32_vfild(void);
int is_ia32_vfild(const ir_node *n);
/**
 * construct vfild node
 */
ir_node *new_bd_ia32_vfild(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem);

extern ir_op *op_ia32_OrMem;
ir_op *get_op_ia32_OrMem(void);
int is_ia32_OrMem(const ir_node *n);
/**
 * construct OrMem node
 */
ir_node *new_bd_ia32_OrMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_fsubp;
ir_op *get_op_ia32_fsubp(void);
int is_ia32_fsubp(const ir_node *n);

extern ir_op *op_ia32_fldlg2;
ir_op *get_op_ia32_fldlg2(void);
int is_ia32_fldlg2(const ir_node *n);
/**
 * construct fldlg2 node
 */
ir_node *new_bd_ia32_fldlg2(dbg_info *db, ir_node *block, ir_mode *mode);

extern ir_op *op_ia32_vfldln2;
ir_op *get_op_ia32_vfldln2(void);
int is_ia32_vfldln2(const ir_node *n);
/**
 * construct vfldln2 node
 */
ir_node *new_bd_ia32_vfldln2(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_fld1;
ir_op *get_op_ia32_fld1(void);
int is_ia32_fld1(const ir_node *n);
/**
 * construct fld1 node
 */
ir_node *new_bd_ia32_fld1(dbg_info *db, ir_node *block, ir_mode *mode);

extern ir_op *op_ia32_Conv_FP2I;
ir_op *get_op_ia32_Conv_FP2I(void);
int is_ia32_Conv_FP2I(const ir_node *n);
/**
 * construct Conv_FP2I node
 */
ir_node *new_bd_ia32_Conv_FP2I(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_Ror;
ir_op *get_op_ia32_Ror(void);
int is_ia32_Ror(const ir_node *n);
/**
 * construct Ror node
 */
ir_node *new_bd_ia32_Ror(dbg_info *db, ir_node *block, ir_node *val, ir_node *count);

extern ir_op *op_ia32_fpremp;
ir_op *get_op_ia32_fpremp(void);
int is_ia32_fpremp(const ir_node *n);

extern ir_op *op_ia32_Shl;
ir_op *get_op_ia32_Shl(void);
int is_ia32_Shl(const ir_node *n);
/**
 * construct Shl node
 */
ir_node *new_bd_ia32_Shl(dbg_info *db, ir_node *block, ir_node *val, ir_node *count);

extern ir_op *op_ia32_AndMem8Bit;
ir_op *get_op_ia32_AndMem8Bit(void);
int is_ia32_AndMem8Bit(const ir_node *n);
/**
 * construct AndMem8Bit node
 */
ir_node *new_bd_ia32_AndMem8Bit(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_fistp;
ir_op *get_op_ia32_fistp(void);
int is_ia32_fistp(const ir_node *n);

extern ir_op *op_ia32_Add;
ir_op *get_op_ia32_Add(void);
int is_ia32_Add(const ir_node *n);
/**
 * construct Add node
 */
ir_node *new_bd_ia32_Add(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_SubSP;
ir_op *get_op_ia32_SubSP(void);
int is_ia32_SubSP(const ir_node *n);
/**
 * construct SubSP node
 */
ir_node *new_bd_ia32_SubSP(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *stack, ir_node *size);

extern ir_op *op_ia32_Conv_I2I;
ir_op *get_op_ia32_Conv_I2I(void);
int is_ia32_Conv_I2I(const ir_node *n);
/**
 * construct Conv_I2I node
 */
ir_node *new_bd_ia32_Conv_I2I(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val, ir_mode *smaller_mode);

extern ir_op *op_ia32_fxch;
ir_op *get_op_ia32_fxch(void);
int is_ia32_fxch(const ir_node *n);
/**
 * construct fxch node
 */
ir_node *new_bd_ia32_fxch(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_fchs;
ir_op *get_op_ia32_fchs(void);
int is_ia32_fchs(const ir_node *n);

extern ir_op *op_ia32_ShrD;
ir_op *get_op_ia32_ShrD(void);
int is_ia32_ShrD(const ir_node *n);
/**
 * construct ShrD node
 */
ir_node *new_bd_ia32_ShrD(dbg_info *db, ir_node *block, ir_node *val_high, ir_node *val_low, ir_node *count);

extern ir_op *op_ia32_fstp;
ir_op *get_op_ia32_fstp(void);
int is_ia32_fstp(const ir_node *n);

extern ir_op *op_ia32_l_SarDep;
ir_op *get_op_ia32_l_SarDep(void);
int is_ia32_l_SarDep(const ir_node *n);
/**
 * construct l_SarDep node
 */
ir_node *new_bd_ia32_l_SarDep(dbg_info *db, ir_node *block, ir_node *val, ir_node *count, ir_node *dep, ir_mode *mode);

extern ir_op *op_ia32_vfmul;
ir_op *get_op_ia32_vfmul(void);
int is_ia32_vfmul(const ir_node *n);
/**
 * construct vfmul node
 */
ir_node *new_bd_ia32_vfmul(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right, ir_node *fpcw);

extern ir_op *op_ia32_vfist;
ir_op *get_op_ia32_vfist(void);
int is_ia32_vfist(const ir_node *n);
/**
 * construct vfist node
 */
ir_node *new_bd_ia32_vfist(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val, ir_node *fpcw);

extern ir_op *op_ia32_Cwtl;
ir_op *get_op_ia32_Cwtl(void);
int is_ia32_Cwtl(const ir_node *n);
/**
 * construct Cwtl node
 */
ir_node *new_bd_ia32_Cwtl(dbg_info *db, ir_node *block, ir_node *val);

extern ir_op *op_ia32_fabs;
ir_op *get_op_ia32_fabs(void);
int is_ia32_fabs(const ir_node *n);

extern ir_op *op_ia32_vfdiv;
ir_op *get_op_ia32_vfdiv(void);
int is_ia32_vfdiv(const ir_node *n);
/**
 * construct vfdiv node
 */
ir_node *new_bd_ia32_vfdiv(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *dividend, ir_node *divisor, ir_node *fpcw);

extern ir_op *op_ia32_Unknown_XMM;
ir_op *get_op_ia32_Unknown_XMM(void);
int is_ia32_Unknown_XMM(const ir_node *n);
/**
 * construct Unknown_XMM node
 */
ir_node *new_bd_ia32_Unknown_XMM(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_fldpi;
ir_op *get_op_ia32_fldpi(void);
int is_ia32_fldpi(const ir_node *n);
/**
 * construct fldpi node
 */
ir_node *new_bd_ia32_fldpi(dbg_info *db, ir_node *block, ir_mode *mode);

extern ir_op *op_ia32_Leave;
ir_op *get_op_ia32_Leave(void);
int is_ia32_Leave(const ir_node *n);
/**
 * construct Leave node
 */
ir_node *new_bd_ia32_Leave(dbg_info *db, ir_node *block, ir_node *op0);

extern ir_op *op_ia32_NoReg_VFP;
ir_op *get_op_ia32_NoReg_VFP(void);
int is_ia32_NoReg_VFP(const ir_node *n);
/**
 * construct NoReg_VFP node
 */
ir_node *new_bd_ia32_NoReg_VFP(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_Neg;
ir_op *get_op_ia32_Neg(void);
int is_ia32_Neg(const ir_node *n);
/**
 * construct Neg node
 */
ir_node *new_bd_ia32_Neg(dbg_info *db, ir_node *block, ir_node *val);

extern ir_op *op_ia32_IMul1OP;
ir_op *get_op_ia32_IMul1OP(void);
int is_ia32_IMul1OP(const ir_node *n);
/**
 * construct IMul1OP node
 */
ir_node *new_bd_ia32_IMul1OP(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_PopMem;
ir_op *get_op_ia32_PopMem(void);
int is_ia32_PopMem(const ir_node *n);
/**
 * construct PopMem node
 */
ir_node *new_bd_ia32_PopMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *stack);

extern ir_op *op_ia32_fld;
ir_op *get_op_ia32_fld(void);
int is_ia32_fld(const ir_node *n);

extern ir_op *op_ia32_Dec;
ir_op *get_op_ia32_Dec(void);
int is_ia32_Dec(const ir_node *n);
/**
 * construct Dec node
 */
ir_node *new_bd_ia32_Dec(dbg_info *db, ir_node *block, ir_node *val);

extern ir_op *op_ia32_Pop;
ir_op *get_op_ia32_Pop(void);
int is_ia32_Pop(const ir_node *n);
/**
 * construct Pop node
 */
ir_node *new_bd_ia32_Pop(dbg_info *db, ir_node *block, ir_node *mem, ir_node *stack);

extern ir_op *op_ia32_faddp;
ir_op *get_op_ia32_faddp(void);
int is_ia32_faddp(const ir_node *n);

extern ir_op *op_ia32_Not;
ir_op *get_op_ia32_Not(void);
int is_ia32_Not(const ir_node *n);
/**
 * construct Not node
 */
ir_node *new_bd_ia32_Not(dbg_info *db, ir_node *block, ir_node *val);

extern ir_op *op_ia32_l_ShrDep;
ir_op *get_op_ia32_l_ShrDep(void);
int is_ia32_l_ShrDep(const ir_node *n);
/**
 * construct l_ShrDep node
 */
ir_node *new_bd_ia32_l_ShrDep(dbg_info *db, ir_node *block, ir_node *val, ir_node *count, ir_node *dep, ir_mode *mode);

extern ir_op *op_ia32_AndMem;
ir_op *get_op_ia32_AndMem(void);
int is_ia32_AndMem(const ir_node *n);
/**
 * construct AndMem node
 */
ir_node *new_bd_ia32_AndMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_femms;
ir_op *get_op_ia32_femms(void);
int is_ia32_femms(const ir_node *n);
/**
 * construct femms node
 */
ir_node *new_bd_ia32_femms(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_xStoreSimple;
ir_op *get_op_ia32_xStoreSimple(void);
int is_ia32_xStoreSimple(const ir_node *n);
/**
 * construct xStoreSimple node
 */
ir_node *new_bd_ia32_xStoreSimple(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *val);

extern ir_op *op_ia32_And;
ir_op *get_op_ia32_And(void);
int is_ia32_And(const ir_node *n);
/**
 * construct And node
 */
ir_node *new_bd_ia32_And(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_Jcc;
ir_op *get_op_ia32_Jcc(void);
int is_ia32_Jcc(const ir_node *n);
/**
 * construct Jcc node
 */
ir_node *new_bd_ia32_Jcc(dbg_info *db, ir_node *block, ir_node *eflags, pn_Cmp pnc);

extern ir_op *op_ia32_SetMem;
ir_op *get_op_ia32_SetMem(void);
int is_ia32_SetMem(const ir_node *n);
/**
 * construct SetMem node
 */
ir_node *new_bd_ia32_SetMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *eflags, pn_Cmp pnc, int ins_permuted);

extern ir_op *op_ia32_Asm;
ir_op *get_op_ia32_Asm(void);
int is_ia32_Asm(const ir_node *n);
/**
 * construct Asm node
 */
ir_node *new_bd_ia32_Asm(dbg_info *db, ir_node *block, int arity, ir_node *in[], int n_res, ident *asm_text, const ia32_asm_reg_t *register_map);

extern ir_op *op_ia32_l_Sbb;
ir_op *get_op_ia32_l_Sbb(void);
int is_ia32_l_Sbb(const ir_node *n);
/**
 * construct l_Sbb node
 */
ir_node *new_bd_ia32_l_Sbb(dbg_info *db, ir_node *block, ir_node *minuend, ir_node *subtrahend, ir_node *eflags, ir_mode *mode);

extern ir_op *op_ia32_SarMem;
ir_op *get_op_ia32_SarMem(void);
int is_ia32_SarMem(const ir_node *n);
/**
 * construct SarMem node
 */
ir_node *new_bd_ia32_SarMem(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *count);

extern ir_op *op_ia32_RepPrefix;
ir_op *get_op_ia32_RepPrefix(void);
int is_ia32_RepPrefix(const ir_node *n);
/**
 * construct RepPrefix node
 */
ir_node *new_bd_ia32_RepPrefix(dbg_info *db, ir_node *block);

extern ir_op *op_ia32_Adc;
ir_op *get_op_ia32_Adc(void);
int is_ia32_Adc(const ir_node *n);
/**
 * construct Adc node
 */
ir_node *new_bd_ia32_Adc(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right, ir_node *eflags);

extern ir_op *op_ia32_l_ShlDep;
ir_op *get_op_ia32_l_ShlDep(void);
int is_ia32_l_ShlDep(const ir_node *n);
/**
 * construct l_ShlDep node
 */
ir_node *new_bd_ia32_l_ShlDep(dbg_info *db, ir_node *block, ir_node *val, ir_node *count, ir_node *dep, ir_mode *mode);

extern ir_op *op_ia32_l_Mul;
ir_op *get_op_ia32_l_Mul(void);
int is_ia32_l_Mul(const ir_node *n);
/**
 * construct l_Mul node
 */
ir_node *new_bd_ia32_l_Mul(dbg_info *db, ir_node *block, ir_node *op0, ir_node *op1);

extern ir_op *op_ia32_xAndNot;
ir_op *get_op_ia32_xAndNot(void);
int is_ia32_xAndNot(const ir_node *n);
/**
 * construct xAndNot node
 */
ir_node *new_bd_ia32_xAndNot(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem, ir_node *left, ir_node *right);

extern ir_op *op_ia32_Load;
ir_op *get_op_ia32_Load(void);
int is_ia32_Load(const ir_node *n);
/**
 * construct Load node
 */
ir_node *new_bd_ia32_Load(dbg_info *db, ir_node *block, ir_node *base, ir_node *index, ir_node *mem);


enum n_ia32_FldCW {
	n_ia32_FldCW_base = 0,
	n_ia32_FldCW_index = 1,
	n_ia32_FldCW_mem = 2,
};

enum n_ia32_ShrMem {
	n_ia32_ShrMem_base = 0,
	n_ia32_ShrMem_index = 1,
	n_ia32_ShrMem_mem = 2,
	n_ia32_ShrMem_count = 3,
};

enum n_ia32_CvtSI2SS {
	n_ia32_CvtSI2SS_base = 0,
	n_ia32_CvtSI2SS_index = 1,
	n_ia32_CvtSI2SS_mem = 2,
	n_ia32_CvtSI2SS_val = 3,
};

enum pn_ia32_ShlD {
	pn_ia32_ShlD_res = 0,
	pn_ia32_ShlD_flags = 1,
};

enum n_ia32_ShlD {
	n_ia32_ShlD_val_high = 0,
	n_ia32_ShlD_val_low = 1,
	n_ia32_ShlD_count = 2,
};

enum pn_ia32_PopEbp {
	pn_ia32_PopEbp_res = 0,
	pn_ia32_PopEbp_M = 1,
	pn_ia32_PopEbp_unused = 2,
	pn_ia32_PopEbp_stack = 3,
};

enum n_ia32_PopEbp {
	n_ia32_PopEbp_mem = 0,
	n_ia32_PopEbp_stack = 1,
};

enum pn_ia32_Inc {
	pn_ia32_Inc_res = 0,
	pn_ia32_Inc_flags = 1,
};

enum n_ia32_Inc {
	n_ia32_Inc_val = 0,
};

enum pn_ia32_xStore {
	pn_ia32_xStore_M = 0,
	pn_ia32_xStore_X_exc = 1,
};

enum n_ia32_xStore {
	n_ia32_xStore_base = 0,
	n_ia32_xStore_index = 1,
	n_ia32_xStore_mem = 2,
	n_ia32_xStore_val = 3,
};

enum n_ia32_l_ShlD {
	n_ia32_l_ShlD_val_high = 0,
	n_ia32_l_ShlD_val_low = 1,
	n_ia32_l_ShlD_count = 2,
};

enum pn_ia32_xxLoad {
	pn_ia32_xxLoad_res = 0,
	pn_ia32_xxLoad_M = 1,
};

enum n_ia32_xAnd {
	n_ia32_xAnd_base = 0,
	n_ia32_xAnd_index = 1,
	n_ia32_xAnd_mem = 2,
	n_ia32_xAnd_left = 3,
	n_ia32_xAnd_right = 4,
};

enum n_ia32_xAdd {
	n_ia32_xAdd_base = 0,
	n_ia32_xAdd_index = 1,
	n_ia32_xAdd_mem = 2,
	n_ia32_xAdd_left = 3,
	n_ia32_xAdd_right = 4,
};

enum n_ia32_xxStore {
	n_ia32_xxStore_base = 0,
	n_ia32_xxStore_index = 1,
	n_ia32_xxStore_mem = 2,
	n_ia32_xxStore_val = 3,
};

enum pn_ia32_Call {
	pn_ia32_Call_stack = 0,
	pn_ia32_Call_fpcw = 1,
	pn_ia32_Call_M = 2,
	pn_ia32_Call_eax = 3,
	pn_ia32_Call_ecx = 4,
	pn_ia32_Call_edx = 5,
	pn_ia32_Call_vf0 = 6,
	pn_ia32_Call_vf1 = 7,
	pn_ia32_Call_vf2 = 8,
	pn_ia32_Call_vf3 = 9,
	pn_ia32_Call_vf4 = 10,
	pn_ia32_Call_vf5 = 11,
	pn_ia32_Call_vf6 = 12,
	pn_ia32_Call_vf7 = 13,
	pn_ia32_Call_xmm0 = 14,
	pn_ia32_Call_xmm1 = 15,
	pn_ia32_Call_xmm2 = 16,
	pn_ia32_Call_xmm3 = 17,
	pn_ia32_Call_xmm4 = 18,
	pn_ia32_Call_xmm5 = 19,
	pn_ia32_Call_xmm6 = 20,
	pn_ia32_Call_xmm7 = 21,
};

enum n_ia32_Call {
	n_ia32_Call_base = 0,
	n_ia32_Call_index = 1,
	n_ia32_Call_mem = 2,
	n_ia32_Call_addr = 3,
	n_ia32_Call_stack = 4,
	n_ia32_Call_fpcw = 5,
	n_ia32_Call_eax = 6,
	n_ia32_Call_ecx = 7,
	n_ia32_Call_edx = 8,
};

enum n_ia32_FnstCWNOP {
	n_ia32_FnstCWNOP_fpcw = 0,
};

enum pn_ia32_vFtstFnstsw {
	pn_ia32_vFtstFnstsw_flags = 0,
};

enum n_ia32_vFtstFnstsw {
	n_ia32_vFtstFnstsw_left = 0,
};

enum n_ia32_XorMem8Bit {
	n_ia32_XorMem8Bit_base = 0,
	n_ia32_XorMem8Bit_index = 1,
	n_ia32_XorMem8Bit_mem = 2,
	n_ia32_XorMem8Bit_val = 3,
};

enum n_ia32_DecMem {
	n_ia32_DecMem_base = 0,
	n_ia32_DecMem_index = 1,
	n_ia32_DecMem_mem = 2,
};

enum n_ia32_vfprem {
	n_ia32_vfprem_left = 0,
	n_ia32_vfprem_right = 1,
	n_ia32_vfprem_fpcw = 2,
};

enum pn_ia32_xLoad {
	pn_ia32_xLoad_res = 0,
	pn_ia32_xLoad_M = 1,
	pn_ia32_xLoad_X_exc = 2,
};

enum n_ia32_xLoad {
	n_ia32_xLoad_base = 0,
	n_ia32_xLoad_index = 1,
	n_ia32_xLoad_mem = 2,
};

enum pn_ia32_l_FloattoLL {
	pn_ia32_l_FloattoLL_res_high = 0,
	pn_ia32_l_FloattoLL_res_low = 1,
};

enum n_ia32_l_FloattoLL {
	n_ia32_l_FloattoLL_val = 0,
};

enum n_ia32_CvtSI2SD {
	n_ia32_CvtSI2SD_base = 0,
	n_ia32_CvtSI2SD_index = 1,
	n_ia32_CvtSI2SD_mem = 2,
	n_ia32_CvtSI2SD_val = 3,
};

enum pn_ia32_vfldpi {
	pn_ia32_vfldpi_res = 0,
};

enum n_ia32_XorMem {
	n_ia32_XorMem_base = 0,
	n_ia32_XorMem_index = 1,
	n_ia32_XorMem_mem = 2,
	n_ia32_XorMem_val = 3,
};

enum n_ia32_vfsub {
	n_ia32_vfsub_base = 0,
	n_ia32_vfsub_index = 1,
	n_ia32_vfsub_mem = 2,
	n_ia32_vfsub_minuend = 3,
	n_ia32_vfsub_subtrahend = 4,
	n_ia32_vfsub_fpcw = 5,
};

enum pn_ia32_CopyB {
	pn_ia32_CopyB_DST = 0,
	pn_ia32_CopyB_SRC = 1,
	pn_ia32_CopyB_CNT = 2,
	pn_ia32_CopyB_M = 3,
};

enum pn_ia32_Sar {
	pn_ia32_Sar_res = 0,
	pn_ia32_Sar_flags = 1,
};

enum n_ia32_Sar {
	n_ia32_Sar_val = 0,
	n_ia32_Sar_count = 1,
};

enum pn_ia32_Div {
	pn_ia32_Div_div_res = 0,
	pn_ia32_Div_flags = 1,
	pn_ia32_Div_M = 2,
	pn_ia32_Div_mod_res = 3,
	pn_ia32_Div_X_exc = 4,
};

enum n_ia32_Div {
	n_ia32_Div_base = 0,
	n_ia32_Div_index = 1,
	n_ia32_Div_mem = 2,
	n_ia32_Div_divisor = 3,
	n_ia32_Div_dividend_low = 4,
	n_ia32_Div_dividend_high = 5,
};

enum pn_ia32_Enter {
	pn_ia32_Enter_frame = 0,
	pn_ia32_Enter_stack = 1,
	pn_ia32_Enter_M = 2,
};

enum pn_ia32_l_IMul {
	pn_ia32_l_IMul_res_low = 0,
	pn_ia32_l_IMul_res_high = 1,
	pn_ia32_l_IMul_M = 2,
};

enum n_ia32_xMax {
	n_ia32_xMax_base = 0,
	n_ia32_xMax_index = 1,
	n_ia32_xMax_mem = 2,
	n_ia32_xMax_left = 3,
	n_ia32_xMax_right = 4,
};

enum n_ia32_OrMem8Bit {
	n_ia32_OrMem8Bit_base = 0,
	n_ia32_OrMem8Bit_index = 1,
	n_ia32_OrMem8Bit_mem = 2,
	n_ia32_OrMem8Bit_val = 3,
};

enum n_ia32_Lea {
	n_ia32_Lea_base = 0,
	n_ia32_Lea_index = 1,
};

enum n_ia32_NotMem {
	n_ia32_NotMem_base = 0,
	n_ia32_NotMem_index = 1,
	n_ia32_NotMem_mem = 2,
};

enum pn_ia32_vFucomi {
	pn_ia32_vFucomi_flags = 0,
};

enum n_ia32_vFucomi {
	n_ia32_vFucomi_left = 0,
	n_ia32_vFucomi_right = 1,
};

enum n_ia32_Bt {
	n_ia32_Bt_left = 0,
	n_ia32_Bt_right = 1,
};

enum n_ia32_vfabs {
	n_ia32_vfabs_value = 0,
};

enum pn_ia32_Or {
	pn_ia32_Or_res = 0,
	pn_ia32_Or_flags = 1,
	pn_ia32_Or_M = 2,
};

enum n_ia32_Or {
	n_ia32_Or_base = 0,
	n_ia32_Or_index = 1,
	n_ia32_Or_mem = 2,
	n_ia32_Or_left = 3,
	n_ia32_Or_right = 4,
};

enum pn_ia32_Xor {
	pn_ia32_Xor_res = 0,
	pn_ia32_Xor_flags = 1,
	pn_ia32_Xor_M = 2,
};

enum n_ia32_Xor {
	n_ia32_Xor_base = 0,
	n_ia32_Xor_index = 1,
	n_ia32_Xor_mem = 2,
	n_ia32_Xor_left = 3,
	n_ia32_Xor_right = 4,
};

enum pn_ia32_CopyB_i {
	pn_ia32_CopyB_i_DST = 0,
	pn_ia32_CopyB_i_SRC = 1,
	pn_ia32_CopyB_i_M = 2,
};

enum n_ia32_IncMem {
	n_ia32_IncMem_base = 0,
	n_ia32_IncMem_index = 1,
	n_ia32_IncMem_mem = 2,
};

enum pn_ia32_vfldlg2 {
	pn_ia32_vfldlg2_res = 0,
};

enum n_ia32_SubMem {
	n_ia32_SubMem_base = 0,
	n_ia32_SubMem_index = 1,
	n_ia32_SubMem_mem = 2,
	n_ia32_SubMem_subtrahend = 3,
};

enum pn_ia32_vfisttp {
	pn_ia32_vfisttp_res = 0,
	pn_ia32_vfisttp_M = 1,
};

enum n_ia32_vfisttp {
	n_ia32_vfisttp_base = 0,
	n_ia32_vfisttp_index = 1,
	n_ia32_vfisttp_mem = 2,
	n_ia32_vfisttp_val = 3,
};

enum n_ia32_AddMem {
	n_ia32_AddMem_base = 0,
	n_ia32_AddMem_index = 1,
	n_ia32_AddMem_mem = 2,
	n_ia32_AddMem_val = 3,
};

enum n_ia32_ShlMem {
	n_ia32_ShlMem_base = 0,
	n_ia32_ShlMem_index = 1,
	n_ia32_ShlMem_mem = 2,
	n_ia32_ShlMem_count = 3,
};

enum pn_ia32_vfldl2e {
	pn_ia32_vfldl2e_res = 0,
};

enum n_ia32_xMin {
	n_ia32_xMin_base = 0,
	n_ia32_xMin_index = 1,
	n_ia32_xMin_mem = 2,
	n_ia32_xMin_left = 3,
	n_ia32_xMin_right = 4,
};

enum n_ia32_xXor {
	n_ia32_xXor_base = 0,
	n_ia32_xXor_index = 1,
	n_ia32_xXor_mem = 2,
	n_ia32_xXor_left = 3,
	n_ia32_xXor_right = 4,
};

enum n_ia32_IJmp {
	n_ia32_IJmp_base = 0,
	n_ia32_IJmp_index = 1,
	n_ia32_IJmp_mem = 2,
	n_ia32_IJmp_target = 3,
};

enum n_ia32_NegMem {
	n_ia32_NegMem_base = 0,
	n_ia32_NegMem_index = 1,
	n_ia32_NegMem_mem = 2,
};

enum pn_ia32_Mul {
	pn_ia32_Mul_res_low = 0,
	pn_ia32_Mul_flags = 1,
	pn_ia32_Mul_res_high = 2,
	pn_ia32_Mul_M = 3,
};

enum n_ia32_Mul {
	n_ia32_Mul_base = 0,
	n_ia32_Mul_index = 1,
	n_ia32_Mul_mem = 2,
	n_ia32_Mul_left = 3,
	n_ia32_Mul_right = 4,
};

enum pn_ia32_Sahf {
	pn_ia32_Sahf_flags = 0,
};

enum n_ia32_Sahf {
	n_ia32_Sahf_val = 0,
};

enum pn_ia32_vfld1 {
	pn_ia32_vfld1_res = 0,
};

enum n_ia32_SubMem8Bit {
	n_ia32_SubMem8Bit_base = 0,
	n_ia32_SubMem8Bit_index = 1,
	n_ia32_SubMem8Bit_mem = 2,
	n_ia32_SubMem8Bit_subtrahend = 3,
};

enum n_ia32_AddMem8Bit {
	n_ia32_AddMem8Bit_base = 0,
	n_ia32_AddMem8Bit_index = 1,
	n_ia32_AddMem8Bit_mem = 2,
	n_ia32_AddMem8Bit_val = 3,
};

enum n_ia32_vfadd {
	n_ia32_vfadd_base = 0,
	n_ia32_vfadd_index = 1,
	n_ia32_vfadd_mem = 2,
	n_ia32_vfadd_left = 3,
	n_ia32_vfadd_right = 4,
	n_ia32_vfadd_fpcw = 5,
};

enum pn_ia32_vfld {
	pn_ia32_vfld_res = 0,
	pn_ia32_vfld_M = 1,
	pn_ia32_vfld_X_exc = 2,
};

enum n_ia32_vfld {
	n_ia32_vfld_base = 0,
	n_ia32_vfld_index = 1,
	n_ia32_vfld_mem = 2,
};

enum n_ia32_vfchs {
	n_ia32_vfchs_value = 0,
};

enum n_ia32_RorMem {
	n_ia32_RorMem_base = 0,
	n_ia32_RorMem_index = 1,
	n_ia32_RorMem_mem = 2,
	n_ia32_RorMem_count = 3,
};

enum n_ia32_xOr {
	n_ia32_xOr_base = 0,
	n_ia32_xOr_index = 1,
	n_ia32_xOr_mem = 2,
	n_ia32_xOr_left = 3,
	n_ia32_xOr_right = 4,
};

enum n_ia32_Conv_I2I8Bit {
	n_ia32_Conv_I2I8Bit_base = 0,
	n_ia32_Conv_I2I8Bit_index = 1,
	n_ia32_Conv_I2I8Bit_mem = 2,
	n_ia32_Conv_I2I8Bit_val = 3,
};

enum pn_ia32_Store {
	pn_ia32_Store_M = 0,
	pn_ia32_Store_X_exc = 1,
};

enum n_ia32_Store {
	n_ia32_Store_base = 0,
	n_ia32_Store_index = 1,
	n_ia32_Store_mem = 2,
	n_ia32_Store_val = 3,
};

enum pn_ia32_IMul {
	pn_ia32_IMul_res = 0,
	pn_ia32_IMul_flags = 1,
	pn_ia32_IMul_M = 2,
};

enum n_ia32_IMul {
	n_ia32_IMul_base = 0,
	n_ia32_IMul_index = 1,
	n_ia32_IMul_mem = 2,
	n_ia32_IMul_left = 3,
	n_ia32_IMul_right = 4,
};

enum n_ia32_l_ShrD {
	n_ia32_l_ShrD_val_high = 0,
	n_ia32_l_ShrD_val_low = 1,
	n_ia32_l_ShrD_count = 2,
};

enum pn_ia32_Ucomi {
	pn_ia32_Ucomi_flags = 0,
};

enum n_ia32_Ucomi {
	n_ia32_Ucomi_base = 0,
	n_ia32_Ucomi_index = 1,
	n_ia32_Ucomi_mem = 2,
	n_ia32_Ucomi_left = 3,
	n_ia32_Ucomi_right = 4,
};

enum n_ia32_CMov {
	n_ia32_CMov_base = 0,
	n_ia32_CMov_index = 1,
	n_ia32_CMov_mem = 2,
	n_ia32_CMov_val_false = 3,
	n_ia32_CMov_val_true = 4,
	n_ia32_CMov_eflags = 5,
};

enum pn_ia32_Store8Bit {
	pn_ia32_Store8Bit_M = 0,
	pn_ia32_Store8Bit_X_exc = 1,
};

enum n_ia32_Store8Bit {
	n_ia32_Store8Bit_base = 0,
	n_ia32_Store8Bit_index = 1,
	n_ia32_Store8Bit_mem = 2,
	n_ia32_Store8Bit_val = 3,
};

enum n_ia32_l_Sub {
	n_ia32_l_Sub_minuend = 0,
	n_ia32_l_Sub_subtrahend = 1,
};

enum pn_ia32_Sbb {
	pn_ia32_Sbb_res = 0,
	pn_ia32_Sbb_flags = 1,
	pn_ia32_Sbb_M = 2,
};

enum n_ia32_Sbb {
	n_ia32_Sbb_base = 0,
	n_ia32_Sbb_index = 1,
	n_ia32_Sbb_mem = 2,
	n_ia32_Sbb_minuend = 3,
	n_ia32_Sbb_subtrahend = 4,
	n_ia32_Sbb_eflags = 5,
};

enum n_ia32_Set {
	n_ia32_Set_eflags = 0,
};

enum n_ia32_xMul {
	n_ia32_xMul_base = 0,
	n_ia32_xMul_index = 1,
	n_ia32_xMul_mem = 2,
	n_ia32_xMul_left = 3,
	n_ia32_xMul_right = 4,
};

enum pn_ia32_Push {
	pn_ia32_Push_stack = 0,
	pn_ia32_Push_M = 1,
};

enum n_ia32_Push {
	n_ia32_Push_base = 0,
	n_ia32_Push_index = 1,
	n_ia32_Push_mem = 2,
	n_ia32_Push_val = 3,
	n_ia32_Push_stack = 4,
};

enum pn_ia32_Cmp {
	pn_ia32_Cmp_eflags = 0,
	pn_ia32_Cmp_unused = 1,
	pn_ia32_Cmp_M = 2,
};

enum n_ia32_Cmp {
	n_ia32_Cmp_base = 0,
	n_ia32_Cmp_index = 1,
	n_ia32_Cmp_mem = 2,
	n_ia32_Cmp_left = 3,
	n_ia32_Cmp_right = 4,
};

enum pn_ia32_vfldl2t {
	pn_ia32_vfldl2t_res = 0,
};

enum n_ia32_xSub {
	n_ia32_xSub_base = 0,
	n_ia32_xSub_index = 1,
	n_ia32_xSub_mem = 2,
	n_ia32_xSub_minuend = 3,
	n_ia32_xSub_subtrahend = 4,
};

enum pn_ia32_vfst {
	pn_ia32_vfst_M = 0,
	pn_ia32_vfst_X_exc = 1,
};

enum n_ia32_vfst {
	n_ia32_vfst_base = 0,
	n_ia32_vfst_index = 1,
	n_ia32_vfst_mem = 2,
	n_ia32_vfst_val = 3,
};

enum n_ia32_Cltd {
	n_ia32_Cltd_val = 0,
	n_ia32_Cltd_clobbered = 1,
};

enum pn_ia32_Rol {
	pn_ia32_Rol_res = 0,
	pn_ia32_Rol_flags = 1,
};

enum n_ia32_Rol {
	n_ia32_Rol_val = 0,
	n_ia32_Rol_count = 1,
};

enum pn_ia32_Cmp8Bit {
	pn_ia32_Cmp8Bit_eflags = 0,
};

enum n_ia32_Cmp8Bit {
	n_ia32_Cmp8Bit_base = 0,
	n_ia32_Cmp8Bit_index = 1,
	n_ia32_Cmp8Bit_mem = 2,
	n_ia32_Cmp8Bit_left = 3,
	n_ia32_Cmp8Bit_right = 4,
};

enum pn_ia32_xDiv {
	pn_ia32_xDiv_res = 0,
	pn_ia32_xDiv_M = 1,
};

enum n_ia32_xDiv {
	n_ia32_xDiv_base = 0,
	n_ia32_xDiv_index = 1,
	n_ia32_xDiv_mem = 2,
	n_ia32_xDiv_dividend = 3,
	n_ia32_xDiv_divisor = 4,
};

enum pn_ia32_Test8Bit {
	pn_ia32_Test8Bit_eflags = 0,
};

enum n_ia32_Test8Bit {
	n_ia32_Test8Bit_base = 0,
	n_ia32_Test8Bit_index = 1,
	n_ia32_Test8Bit_mem = 2,
	n_ia32_Test8Bit_left = 3,
	n_ia32_Test8Bit_right = 4,
};

enum pn_ia32_Sub {
	pn_ia32_Sub_res = 0,
	pn_ia32_Sub_flags = 1,
	pn_ia32_Sub_M = 2,
};

enum n_ia32_Sub {
	n_ia32_Sub_base = 0,
	n_ia32_Sub_index = 1,
	n_ia32_Sub_mem = 2,
	n_ia32_Sub_minuend = 3,
	n_ia32_Sub_subtrahend = 4,
};

enum pn_ia32_Shr {
	pn_ia32_Shr_res = 0,
	pn_ia32_Shr_flags = 1,
};

enum n_ia32_Shr {
	n_ia32_Shr_val = 0,
	n_ia32_Shr_count = 1,
};

enum pn_ia32_IDiv {
	pn_ia32_IDiv_div_res = 0,
	pn_ia32_IDiv_flags = 1,
	pn_ia32_IDiv_M = 2,
	pn_ia32_IDiv_mod_res = 3,
	pn_ia32_IDiv_X_exc = 4,
};

enum n_ia32_IDiv {
	n_ia32_IDiv_base = 0,
	n_ia32_IDiv_index = 1,
	n_ia32_IDiv_mem = 2,
	n_ia32_IDiv_divisor = 3,
	n_ia32_IDiv_dividend_low = 4,
	n_ia32_IDiv_dividend_high = 5,
};

enum n_ia32_l_Adc {
	n_ia32_l_Adc_left = 0,
	n_ia32_l_Adc_right = 1,
	n_ia32_l_Adc_eflags = 2,
};

enum n_ia32_l_LLtoFloat {
	n_ia32_l_LLtoFloat_val_high = 0,
	n_ia32_l_LLtoFloat_val_low = 1,
};

enum pn_ia32_vfldz {
	pn_ia32_vfldz_res = 0,
};

enum pn_ia32_vFucomFnstsw {
	pn_ia32_vFucomFnstsw_flags = 0,
};

enum n_ia32_vFucomFnstsw {
	n_ia32_vFucomFnstsw_left = 0,
	n_ia32_vFucomFnstsw_right = 1,
};

enum pn_ia32_Test {
	pn_ia32_Test_eflags = 0,
};

enum n_ia32_Test {
	n_ia32_Test_base = 0,
	n_ia32_Test_index = 1,
	n_ia32_Test_mem = 2,
	n_ia32_Test_left = 3,
	n_ia32_Test_right = 4,
};

enum n_ia32_l_Add {
	n_ia32_l_Add_left = 0,
	n_ia32_l_Add_right = 1,
};

enum pn_ia32_AddSP {
	pn_ia32_AddSP_stack = 0,
	pn_ia32_AddSP_M = 1,
};

enum n_ia32_AddSP {
	n_ia32_AddSP_base = 0,
	n_ia32_AddSP_index = 1,
	n_ia32_AddSP_mem = 2,
	n_ia32_AddSP_stack = 3,
	n_ia32_AddSP_size = 4,
};

enum n_ia32_RolMem {
	n_ia32_RolMem_base = 0,
	n_ia32_RolMem_index = 1,
	n_ia32_RolMem_mem = 2,
	n_ia32_RolMem_count = 3,
};

enum n_ia32_Conv_I2FP {
	n_ia32_Conv_I2FP_base = 0,
	n_ia32_Conv_I2FP_index = 1,
	n_ia32_Conv_I2FP_mem = 2,
	n_ia32_Conv_I2FP_val = 3,
};

enum n_ia32_Conv_FP2FP {
	n_ia32_Conv_FP2FP_base = 0,
	n_ia32_Conv_FP2FP_index = 1,
	n_ia32_Conv_FP2FP_mem = 2,
	n_ia32_Conv_FP2FP_val = 3,
};

enum pn_ia32_Minus64Bit {
	pn_ia32_Minus64Bit_low_res = 0,
	pn_ia32_Minus64Bit_high_res = 1,
};

enum n_ia32_FnstCW {
	n_ia32_FnstCW_base = 0,
	n_ia32_FnstCW_index = 1,
	n_ia32_FnstCW_mem = 2,
	n_ia32_FnstCW_fpcw = 3,
};

enum pn_ia32_vfild {
	pn_ia32_vfild_res = 0,
	pn_ia32_vfild_M = 1,
};

enum n_ia32_vfild {
	n_ia32_vfild_base = 0,
	n_ia32_vfild_index = 1,
	n_ia32_vfild_mem = 2,
};

enum n_ia32_OrMem {
	n_ia32_OrMem_base = 0,
	n_ia32_OrMem_index = 1,
	n_ia32_OrMem_mem = 2,
	n_ia32_OrMem_val = 3,
};

enum pn_ia32_vfldln2 {
	pn_ia32_vfldln2_res = 0,
};

enum n_ia32_Conv_FP2I {
	n_ia32_Conv_FP2I_base = 0,
	n_ia32_Conv_FP2I_index = 1,
	n_ia32_Conv_FP2I_mem = 2,
	n_ia32_Conv_FP2I_val = 3,
};

enum pn_ia32_Ror {
	pn_ia32_Ror_res = 0,
	pn_ia32_Ror_flags = 1,
};

enum n_ia32_Ror {
	n_ia32_Ror_val = 0,
	n_ia32_Ror_count = 1,
};

enum pn_ia32_Shl {
	pn_ia32_Shl_res = 0,
	pn_ia32_Shl_flags = 1,
};

enum n_ia32_Shl {
	n_ia32_Shl_val = 0,
	n_ia32_Shl_count = 1,
};

enum n_ia32_AndMem8Bit {
	n_ia32_AndMem8Bit_base = 0,
	n_ia32_AndMem8Bit_index = 1,
	n_ia32_AndMem8Bit_mem = 2,
	n_ia32_AndMem8Bit_val = 3,
};

enum pn_ia32_Add {
	pn_ia32_Add_res = 0,
	pn_ia32_Add_flags = 1,
	pn_ia32_Add_M = 2,
};

enum n_ia32_Add {
	n_ia32_Add_base = 0,
	n_ia32_Add_index = 1,
	n_ia32_Add_mem = 2,
	n_ia32_Add_left = 3,
	n_ia32_Add_right = 4,
};

enum pn_ia32_SubSP {
	pn_ia32_SubSP_stack = 0,
	pn_ia32_SubSP_addr = 1,
	pn_ia32_SubSP_M = 2,
};

enum n_ia32_SubSP {
	n_ia32_SubSP_base = 0,
	n_ia32_SubSP_index = 1,
	n_ia32_SubSP_mem = 2,
	n_ia32_SubSP_stack = 3,
	n_ia32_SubSP_size = 4,
};

enum pn_ia32_Conv_I2I {
	pn_ia32_Conv_I2I_res = 0,
	pn_ia32_Conv_I2I_M = 1,
};

enum n_ia32_Conv_I2I {
	n_ia32_Conv_I2I_base = 0,
	n_ia32_Conv_I2I_index = 1,
	n_ia32_Conv_I2I_mem = 2,
	n_ia32_Conv_I2I_val = 3,
};

enum pn_ia32_ShrD {
	pn_ia32_ShrD_res = 0,
	pn_ia32_ShrD_flags = 1,
};

enum n_ia32_ShrD {
	n_ia32_ShrD_val_high = 0,
	n_ia32_ShrD_val_low = 1,
	n_ia32_ShrD_count = 2,
};

enum n_ia32_l_SarDep {
	n_ia32_l_SarDep_val = 0,
	n_ia32_l_SarDep_count = 1,
	n_ia32_l_SarDep_dep = 2,
};

enum n_ia32_vfmul {
	n_ia32_vfmul_base = 0,
	n_ia32_vfmul_index = 1,
	n_ia32_vfmul_mem = 2,
	n_ia32_vfmul_left = 3,
	n_ia32_vfmul_right = 4,
	n_ia32_vfmul_fpcw = 5,
};

enum n_ia32_vfist {
	n_ia32_vfist_base = 0,
	n_ia32_vfist_index = 1,
	n_ia32_vfist_mem = 2,
	n_ia32_vfist_val = 3,
	n_ia32_vfist_fpcw = 4,
};

enum pn_ia32_Cwtl {
	pn_ia32_Cwtl_res = 0,
};

enum n_ia32_Cwtl {
	n_ia32_Cwtl_val = 0,
};

enum pn_ia32_vfdiv {
	pn_ia32_vfdiv_res = 0,
	pn_ia32_vfdiv_M = 1,
};

enum n_ia32_vfdiv {
	n_ia32_vfdiv_base = 0,
	n_ia32_vfdiv_index = 1,
	n_ia32_vfdiv_mem = 2,
	n_ia32_vfdiv_dividend = 3,
	n_ia32_vfdiv_divisor = 4,
	n_ia32_vfdiv_fpcw = 5,
};

enum pn_ia32_Leave {
	pn_ia32_Leave_frame = 0,
	pn_ia32_Leave_stack = 1,
};

enum pn_ia32_Neg {
	pn_ia32_Neg_res = 0,
	pn_ia32_Neg_flags = 1,
};

enum n_ia32_Neg {
	n_ia32_Neg_val = 0,
};

enum pn_ia32_IMul1OP {
	pn_ia32_IMul1OP_res_low = 0,
	pn_ia32_IMul1OP_flags = 1,
	pn_ia32_IMul1OP_res_high = 2,
	pn_ia32_IMul1OP_M = 3,
};

enum n_ia32_IMul1OP {
	n_ia32_IMul1OP_base = 0,
	n_ia32_IMul1OP_index = 1,
	n_ia32_IMul1OP_mem = 2,
	n_ia32_IMul1OP_left = 3,
	n_ia32_IMul1OP_right = 4,
};

enum pn_ia32_PopMem {
	pn_ia32_PopMem_unused0 = 0,
	pn_ia32_PopMem_M = 1,
	pn_ia32_PopMem_unused1 = 2,
	pn_ia32_PopMem_stack = 3,
};

enum n_ia32_PopMem {
	n_ia32_PopMem_base = 0,
	n_ia32_PopMem_index = 1,
	n_ia32_PopMem_mem = 2,
	n_ia32_PopMem_stack = 3,
};

enum pn_ia32_Dec {
	pn_ia32_Dec_res = 0,
	pn_ia32_Dec_flags = 1,
};

enum n_ia32_Dec {
	n_ia32_Dec_val = 0,
};

enum pn_ia32_Pop {
	pn_ia32_Pop_res = 0,
	pn_ia32_Pop_M = 1,
	pn_ia32_Pop_unused = 2,
	pn_ia32_Pop_stack = 3,
};

enum n_ia32_Pop {
	n_ia32_Pop_mem = 0,
	n_ia32_Pop_stack = 1,
};

enum pn_ia32_Not {
	pn_ia32_Not_res = 0,
	pn_ia32_Not_flags = 1,
};

enum n_ia32_Not {
	n_ia32_Not_val = 0,
};

enum n_ia32_l_ShrDep {
	n_ia32_l_ShrDep_val = 0,
	n_ia32_l_ShrDep_count = 1,
	n_ia32_l_ShrDep_dep = 2,
};

enum n_ia32_AndMem {
	n_ia32_AndMem_base = 0,
	n_ia32_AndMem_index = 1,
	n_ia32_AndMem_mem = 2,
	n_ia32_AndMem_val = 3,
};

enum n_ia32_xStoreSimple {
	n_ia32_xStoreSimple_base = 0,
	n_ia32_xStoreSimple_index = 1,
	n_ia32_xStoreSimple_mem = 2,
	n_ia32_xStoreSimple_val = 3,
};

enum pn_ia32_And {
	pn_ia32_And_res = 0,
	pn_ia32_And_flags = 1,
	pn_ia32_And_M = 2,
};

enum n_ia32_And {
	n_ia32_And_base = 0,
	n_ia32_And_index = 1,
	n_ia32_And_mem = 2,
	n_ia32_And_left = 3,
	n_ia32_And_right = 4,
};

enum pn_ia32_Jcc {
	pn_ia32_Jcc_false = 0,
	pn_ia32_Jcc_true = 1,
};

enum n_ia32_Jcc {
	n_ia32_Jcc_eflags = 0,
};

enum n_ia32_SetMem {
	n_ia32_SetMem_base = 0,
	n_ia32_SetMem_index = 1,
	n_ia32_SetMem_mem = 2,
	n_ia32_SetMem_eflags = 3,
};

enum n_ia32_l_Sbb {
	n_ia32_l_Sbb_minuend = 0,
	n_ia32_l_Sbb_subtrahend = 1,
	n_ia32_l_Sbb_eflags = 2,
};

enum n_ia32_SarMem {
	n_ia32_SarMem_base = 0,
	n_ia32_SarMem_index = 1,
	n_ia32_SarMem_mem = 2,
	n_ia32_SarMem_count = 3,
};

enum pn_ia32_Adc {
	pn_ia32_Adc_res = 0,
	pn_ia32_Adc_flags = 1,
	pn_ia32_Adc_M = 2,
};

enum n_ia32_Adc {
	n_ia32_Adc_base = 0,
	n_ia32_Adc_index = 1,
	n_ia32_Adc_mem = 2,
	n_ia32_Adc_left = 3,
	n_ia32_Adc_right = 4,
	n_ia32_Adc_eflags = 5,
};

enum n_ia32_l_ShlDep {
	n_ia32_l_ShlDep_val = 0,
	n_ia32_l_ShlDep_count = 1,
	n_ia32_l_ShlDep_dep = 2,
};

enum pn_ia32_l_Mul {
	pn_ia32_l_Mul_EAX = 0,
	pn_ia32_l_Mul_flags = 1,
	pn_ia32_l_Mul_EDX = 2,
	pn_ia32_l_Mul_M = 3,
};

enum n_ia32_xAndNot {
	n_ia32_xAndNot_base = 0,
	n_ia32_xAndNot_index = 1,
	n_ia32_xAndNot_mem = 2,
	n_ia32_xAndNot_left = 3,
	n_ia32_xAndNot_right = 4,
};

enum pn_ia32_Load {
	pn_ia32_Load_res = 0,
	pn_ia32_Load_M = 1,
	pn_ia32_Load_X_exc = 2,
};

enum n_ia32_Load {
	n_ia32_Load_base = 0,
	n_ia32_Load_index = 1,
	n_ia32_Load_mem = 2,
};
#endif
