/**
 * @file
 * @brief     Generated functions to emit code for assembler ir nodes.
 * @note      DO NOT EDIT THIS FILE, your changes will be lost.
 *            Edit libfirm/ir/be/mips/mips_spec.pl instead.
 *            created by: libfirm/ir/be/scripts/generate_emitter.pl libfirm/ir/be/mips/mips_spec.pl libfirm/ir/be/mips
 * @date      Sat Nov 22 08:31:08 2008
 */
#include "config.h"

#include <stdio.h>

#include "irnode.h"
#include "irop_t.h"
#include "irprog_t.h"

#include "gen_mips_emitter.h"
#include "mips_new_nodes.h"
#include "mips_emitter.h"

static void emit_mips_sw(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("sw ");
	mips_emit_source_register(node, 1);
	be_emit_cstring(", ");
	mips_emit_load_store_address(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_mips_lbu(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("lbu ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_load_store_address(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_mips_SwitchJump(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("jr ");
	mips_emit_source_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_mips_seb(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("seb ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_mips_lhu(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("lhu ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_load_store_address(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_mips_or(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("or");
	mips_emit_immediate_suffix(node, 1);
	be_emit_cstring(" ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register_or_immediate(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_mips_mfhi(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("mfhi ");
	mips_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_mips_srl(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("srl ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register_or_immediate(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_mips_sh(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("sh ");
	mips_emit_source_register(node, 1);
	be_emit_cstring(", ");
	mips_emit_load_store_address(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_mips_lb(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("lb ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_load_store_address(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_mips_sra(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("sra ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register_or_immediate(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_mips_beq(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("beq ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 1);
	be_emit_cstring(", ");
	mips_emit_jump_target_proj(node, 1);
	be_emit_finish_line_gas(node);
		             be_emit_char('	');
		             mips_emit_jump_or_fallthrough(node, 0);
		             be_emit_finish_line_gas(node);
}

static void emit_mips_b(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("b ");
	mips_emit_jump_target(node);
	be_emit_finish_line_gas(node);
}

static void emit_mips_sll(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("sll ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register_or_immediate(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_mips_lw(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("lw ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_load_store_address(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_mips_jr(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("jr ");
	mips_emit_source_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_mips_mult(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("mult ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_mips_and(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("and");
	mips_emit_immediate_suffix(node, 1);
	be_emit_cstring(" ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register_or_immediate(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_mips_seh(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("seh ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_mips_lh(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("lh ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_load_store_address(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_mips_div(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("div ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_mips_nop(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("nop");
	be_emit_finish_line_gas(node);
}

static void emit_mips_sltu(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("slt");
	mips_emit_immediate_suffix(node, 1);
	be_emit_cstring("u ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register_or_immediate(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_mips_bne(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("bne ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 1);
	be_emit_cstring(", ");
	mips_emit_jump_target_proj(node, 1);
	be_emit_finish_line_gas(node);
		             be_emit_char('	');
		             mips_emit_jump_or_fallthrough(node, 0);
		             be_emit_finish_line_gas(node);
}

static void emit_mips_subu(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("subu ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_mips_nor(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("nor");
	mips_emit_immediate_suffix(node, 1);
	be_emit_cstring(" ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register_or_immediate(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_mips_multu(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("multu ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_mips_blez(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("blez ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_jump_target_proj(node, 1);
	be_emit_finish_line_gas(node);
		             be_emit_char('	');
		             mips_emit_jump_or_fallthrough(node, 0);
		             be_emit_finish_line_gas(node);
}

static void emit_mips_addu(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("add");
	mips_emit_immediate_suffix(node, 1);
	be_emit_cstring("u ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register_or_immediate(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_mips_mflo(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("mflo ");
	mips_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_mips_zero(const ir_node *node) {
	(void) node;
}

static void emit_mips_sb(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("sb ");
	mips_emit_source_register(node, 1);
	be_emit_cstring(", ");
	mips_emit_load_store_address(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_mips_slt(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("slt");
	mips_emit_immediate_suffix(node, 1);
	be_emit_cstring(" ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register_or_immediate(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_mips_bgtz(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("bgtz ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_jump_target_proj(node, 1);
	be_emit_finish_line_gas(node);
		             be_emit_char('	');
		             mips_emit_jump_or_fallthrough(node, 0);
		             be_emit_finish_line_gas(node);
}

static void emit_mips_xor(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("xor");
	mips_emit_immediate_suffix(node, 1);
	be_emit_cstring(" ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register_or_immediate(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_mips_lui(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("lui ");
	mips_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_immediate(node);
	be_emit_finish_line_gas(node);
}

static void emit_mips_divu(const ir_node *node) {
	be_emit_char('	');
	be_emit_cstring("divu ");
	mips_emit_source_register(node, 0);
	be_emit_cstring(", ");
	mips_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

/**
 * Enters the emitter functions for handled nodes into the generic
 * pointer of an opcode.
 */
void mips_register_spec_emitters(void) {

#define BE_EMIT(a) op_mips_##a->ops.generic = (op_func)emit_mips_##a

  /* generated emitter functions */
  BE_EMIT(sw);
  BE_EMIT(lbu);
  BE_EMIT(SwitchJump);
  BE_EMIT(seb);
  BE_EMIT(lhu);
  BE_EMIT(or);
  BE_EMIT(mfhi);
  BE_EMIT(srl);
  BE_EMIT(sh);
  BE_EMIT(lb);
  BE_EMIT(sra);
  BE_EMIT(beq);
  BE_EMIT(b);
  BE_EMIT(sll);
  BE_EMIT(lw);
  BE_EMIT(jr);
  BE_EMIT(mult);
  BE_EMIT(and);
  BE_EMIT(seh);
  BE_EMIT(lh);
  BE_EMIT(div);
  BE_EMIT(nop);
  BE_EMIT(sltu);
  BE_EMIT(bne);
  BE_EMIT(subu);
  BE_EMIT(nor);
  BE_EMIT(multu);
  BE_EMIT(blez);
  BE_EMIT(addu);
  BE_EMIT(mflo);
  BE_EMIT(zero);
  BE_EMIT(sb);
  BE_EMIT(slt);
  BE_EMIT(bgtz);
  BE_EMIT(xor);
  BE_EMIT(lui);
  BE_EMIT(divu);

#undef BE_EMIT
}

