/*
 * Copyright (C) 1995-2008 University of Karlsruhe.  All right reserved.
 *
 * This file is part of libFirm.
 *
 * This file may be distributed and/or modified under the terms of the
 * GNU General Public License version 2 as published by the Free Software
 * Foundation and appearing in the file LICENSE.GPL included in the
 * packaging of this file.
 *
 * Licensees holding valid libFirm Professional Edition licenses may use
 * this file in accordance with the libFirm Commercial License.
 * Agreement provided with the Software.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 * WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 */

/*
 * Project:     libFIRM
 * File name:   ir/opt/reassoc_t.h
 * Purpose:     Reassociation
 * Author:      Michael Beck
 * Created:
 * CVS-ID:      $Id: reassoc_t.h 17143 2008-01-02 20:56:33Z beck $
 * Copyright:   (c) 1998-2004 Universitt Karlsruhe
 */

/**
 * @file reassoc_t.h
 *
 * Reassociation optimization.
 *
 * @author Michael Beck
 */
#ifndef REASSOC_T_H
#define REASSOC_T_H

#include "iroptimize.h"

/**
 * Sets the default reassociation operation for an ir_op_ops.
 *
 * @param code   the opcode for the default operation
 * @param ops    the operations initialized
 *
 * @return
 *    The operations.
 */
ir_op_ops *firm_set_default_reassoc(ir_opcode code, ir_op_ops *ops);

/** Initialise the ressociation optimization */
void firm_init_reassociation(void);

#endif /* _REASSOC_T_H_ */
